;    DALLAS 1-Wire 
;          DS18xxx
 

 
.EQU	CPU_CLOCK	= 4000000; 
.EQU	CPU_CYCLE 	= 1000000000 / CPU_CLOCK; 250;    CPU  
 
/***************************************************************************/
;  
.EQU	TERMO_PORT	= PORTA;
.EQU	TERMO_DDR	= DDRA;
.EQU	TERMO_PIN	= PINA;
 
;  
.EQU	TERMO_1W	= PA0; 
.EQU	TERMO_2W	= PA1;
.EQU	TERMO_3W	= PA2;
 
.EQU	TERMO_WIRE_MASK = ((1 << TERMO_1W)|(1 << TERMO_2W)|(1 << TERMO_3W));
 
/***************************************************************************/
 
;.EQU   ADRESS_TERMO_Data1W    = 4; r4
 
;    DS1821

.EQU	ONEWIRE_1821_READ_Temp1ERATURE	= 0xAA;    
.EQU	ONEWIRE_1821_WRITE_TH		= 0x01;    
.EQU	ONEWIRE_1821_WRITE_TL		= 0x02;    
.EQU	ONEWIRE_1821_READ_TH		= 0xA1;    
.EQU	ONEWIRE_1821_READ_TL		= 0xA2;    
.EQU	ONEWIRE_1821_WRITE_STATUS	= 0x0C;     
.EQU	ONEWIRE_1821_READ_STATUS	= 0xAC;     
.EQU	ONEWIRE_1821_START_CONVERT_T	= 0xEE;   
.EQU	ONEWIRE_1821_STOP_CONVERT_T	= 0x22;   
 
.EQU	ONEWIRE_18B20_READ_POWER	= 0xB4;   
.EQU	ONEWIRE_18B20_RECALL_EEPROM	= 0xB8;   EEPROM ( 3 )
.EQU	ONEWIRE_18B20_COPY_SCRATCHPAD	= 0x48;    EEPROM ( 3 )
.EQU	ONEWIRE_18B20_WRITE_SCRATCHPAD	= 0x4E;     ( 3 )
.EQU	ONEWIRE_18B20_READ_SCRATCHPAD	= 0xBE;   
.EQU	ONEWIRE_18B20_CONVERT_T		= 0x44;   

.equ	SKIP_ROM			= 0xcc;  SkipROM

/****************************************************************************            
 DALLAS 1-Wire
****************************************************************************/
.EQU   COMM_PER_MCS   = 1000 / CPU_CYCLE          ;   CPU  
.EQU   ONEWIRE_DELAY_CYCLE_TIME            = 4       ;     (. )
 
;  bit transfer layer,   AN126  Dallas Semiconductors
;   AN318  ATMEL
.EQU   ONE_WIRE_DELAY_A        = ((6    * COMM_PER_MCS) / ONEWIRE_DELAY_CYCLE_TIME);
.EQU   ONE_WIRE_DELAY_B        = ((64 * COMM_PER_MCS) / ONEWIRE_DELAY_CYCLE_TIME);
.EQU   ONE_WIRE_DELAY_C        = ((60 * COMM_PER_MCS) / ONEWIRE_DELAY_CYCLE_TIME);
.EQU   ONE_WIRE_DELAY_D        = ((10 * COMM_PER_MCS) / ONEWIRE_DELAY_CYCLE_TIME);
.EQU   ONE_WIRE_DELAY_E        = ((9    * COMM_PER_MCS) / ONEWIRE_DELAY_CYCLE_TIME);
.EQU   ONE_WIRE_DELAY_F        = ((55 * COMM_PER_MCS) / ONEWIRE_DELAY_CYCLE_TIME);
.EQU   ONE_WIRE_DELAY_G        = 0;
.EQU   ONE_WIRE_DELAY_H        = ((480 * COMM_PER_MCS) / ONEWIRE_DELAY_CYCLE_TIME);
.EQU   ONE_WIRE_DELAY_I        = ((70 * COMM_PER_MCS) / ONEWIRE_DELAY_CYCLE_TIME);
.EQU   ONE_WIRE_DELAY_J        = ((410 * COMM_PER_MCS) / ONEWIRE_DELAY_CYCLE_TIME); 
/****************************************************************************            
OneWire_WriteBit1:
   1.      0   1-15 
****************************************************************************/
OneWire_WriteBit1:

;     
	cli
	rcall	OneWire_ClrBus;

;  A    0
	ldi	YL, low(ONE_WIRE_DELAY_A);   
	ldi	YH, high(ONE_WIRE_DELAY_A);

;  B   
	ldi	ZL, low(ONE_WIRE_DELAY_B);    
	ldi	ZH, high(ONE_WIRE_DELAY_B);

	rcall	OneWire_Delay;
	sei
	ret

/****************************************************************************            
OneWire_WriteBit0:
   0.      0   60-120 
****************************************************************************/
OneWire_WriteBit0:

;     
	cli
	rcall	OneWire_ClrBus;
 
;  C    0
	ldi	YL, low(ONE_WIRE_DELAY_C)
	ldi	YH, high(ONE_WIRE_DELAY_C)
 
;  D   
	ldi	ZL, low(ONE_WIRE_DELAY_D)
	ldi	ZH, high(ONE_WIRE_DELAY_D)

	rcall	OneWire_Delay;
	sei
	ret

/****************************************************************************            
OneWire_ReadBit: 
  .      0   1-15 .  , 
   15       0,    0, 
  1,       
 
:	Data1W -   0  3    
****************************************************************************/
OneWire_ReadBit:

;     
	cli
	rcall	OneWire_ClrBus;

;  A    0
	ldi	YL, low(ONE_WIRE_DELAY_A);   
	ldi	YH, high(ONE_WIRE_DELAY_A);

;  E      
	ldi	ZL, low(ONE_WIRE_DELAY_E);    
	ldi	ZH, high(ONE_WIRE_DELAY_E);

	rcall	OneWire_Delay;

;   
	rcall	OneWire_ReadBus;

;  F   
	ldi	YL, low(ONE_WIRE_DELAY_F);    
	ldi	YH, high(ONE_WIRE_DELAY_F);
	rcall	OneWire_Delay;
	sei
	ret

/**************************************************************************** 
OneWire_DetectPresence:
   

: 	Data1W -   0  2  1  ,   
****************************************************************************/
OneWire_DetectPresence:

;     
	cli
	rcall	OneWire_ClrBus;

;  H    0
	ldi	YL, low(ONE_WIRE_DELAY_H);
	ldi	YH, high(ONE_WIRE_DELAY_H);

;  I   
	ldi	ZL, low(ONE_WIRE_DELAY_I);
	ldi	ZH, high(ONE_WIRE_DELAY_I);
	rcall	OneWire_Delay;

;   
	rcall	OneWire_ReadBus;

;  J   
	ldi	YL, low(ONE_WIRE_DELAY_J);
	ldi	YH, high(ONE_WIRE_DELAY_J);
	rcall	OneWire_Delay
	sei
	ret

/****************************************************************************
OneWire_Delay:
   1-Wire
     4  (ONEWIRE_DELAY_CYCLE_TIME) 

:	Y -      0
	Z -     timeslot
****************************************************************************/
OneWire_Delay:

;       Y  
	sbiw	YL, 0x01		;2 
	brne	OneWire_Delay;	2   
 
;  
	in	Temp1, TERMO_DDR;
	andi	Temp1, ~TERMO_WIRE_MASK;
	out	TERMO_DDR, Temp1;
 
;   timslot  Z
OneWire_ReadyTS:
 
	sbiw	ZL, 0x01		;2 
	brne	OneWire_ReadyTS;	 2   
 
;           
;     
	inc	ZL;      
 
	ret;
/****************************************************************************
OneWire_SendByte: 
   

:	Data1W -  
****************************************************************************/
OneWire_SendByte:

;   
	ldi	Temp2, 8;

;     
OneWire_SendByte_Cycle:

;      
	sbrc	Data1W, 0;
	rcall	OneWire_WriteBit1;
	sbrs	Data1W, 0;
	rcall	OneWire_WriteBit0;

;       
	lsr	Data1W;
	dec	Temp2;
	brne	OneWire_SendByte_Cycle;
	ret

/****************************************************************************
OneWire_ReceiveByte:    

:	Data1W -  
****************************************************************************/
OneWire_ReceiveByte:

;   
	ldi	Temp2, 8;

;     
OneWire_ReceiveByte_Cycle:

;   
	lsr	Temp3;
	lsr	Temp4;
	lsr	Temp5;

;      
	rcall	OneWire_ReadBit;

;     
	bst	Data1W, TERMO_1W;
	bld	Temp3, 7;
	bst	Data1W, TERMO_2W;
	bld	Temp4, 7;
	bst	Data1W, TERMO_3W;
	bld	Temp5, 7;

;    
	dec	Temp2;
	brne	OneWire_ReceiveByte_Cycle;
	ret;
 
/****************************************************************************
OneWire_ClrBus: 
    
 
****************************************************************************/
OneWire_ClrBus:

	in	Temp1, TERMO_DDR;
	ori	Temp1, TERMO_WIRE_MASK;
	out	TERMO_DDR, Temp1;
	ret;
 
/***************************************************************************
OneWire_ReadBus: 
  

:	Data1W -   0  2    
****************************************************************************/
OneWire_ReadBus:

;    
	clr	Data1W

;   
	sbic	TERMO_PIN, TERMO_1W;
	sbr	Data1W, (1 << TERMO_1W);
	sbic	TERMO_PIN, TERMO_2W;
	sbr	Data1W, (1 << TERMO_2W);
	sbic	TERMO_PIN, TERMO_3W;
	sbr	Data1W, (1 << TERMO_3W);
owsc_ret:	ret;

/****************************************************************************
OneWire_SendCom:
   

:	Data1Wire () -  
****************************************************************************/
OneWire_SendCom:

	ldio	ADCSRA,0b00101111	; 

	rcall	OneWire_DetectPresence	;       
	out	FlagsTermo, Data1W
	tst	Data1W
	breq	owsc_ret		;  , 
	LOAD	Temp1,FlagsTermo
	andi	Temp1,$f8		;   
	or	Temp1,Data1W	;
	STORE	FlagsTermo,Temp1
	ldi	Data1W,SKIP_ROM	; SkipROM
	rcall	OneWire_SendByte	; 
	LOAD	Data1W,Data1Wire
	rcall	OneWire_SendByte	; 

	ldio	ADCSRA,$ce		; ,  ,  115
	ret
/****************************************************************************
OneWire_ReadData:
   .   DS18B20

****************************************************************************/
OneWire_ReadData:

	ldio	ADCSRA,0b00101111	; 

	ldi	Temp1,ONEWIRE_18B20_READ_SCRATCHPAD	; ReadScratchpad
	STORE	Data1Wire,Temp1
	rcall	OneWire_SendCom
	ldi2	XL,low(Data1WBuf_1),XH,high(Data1WBuf_1)
	ldi	Temp6,9

owrd_loop1:	rcall	OneWire_ReceiveByte	;   
	st	X+,Temp3
	st	X+,Temp4		;   
	st	X+,Temp5
	dec	Temp6
	brne	owrd_loop1

	;rcall	CalcCRC8		; CRC8  8     
	;  CRC c     ,  
	ldi	Temp2,3
	ldi2	ZL,low(Data1WBuf_1),ZH,high(Data1WBuf_1)
	ldi2	XL,low(DataTerm1L),XH,high(DataTerm1L)
owrd_loop2:	ld	Temp1,Z+
	st	X+,Temp1		;   
	ldd	Temp1,Z+2
	st	X+,Temp1		;   
	dec	Temp2
	brne	owrd_loop2
	ldi	Temp1,ONEWIRE_18B20_CONVERT_T	; ConvertT
	STORE	Data1Wire,Temp1
	rjmp	OneWire_SendCom
