;*********************************************************************
;2.  "bin16ASCII15"-  16- 
;   BCD 

; :
;	fASCIIL -   
;	fASCIIH -   

; :
;	tASCII0 -  
;	tASCII1 -  10
;	tASCII2 -  100
;	tASCII3 -  1000
;	tASCII4 -  10000

;.def	Temp5	=r16
;.def	Temp3	=r17
;.def	Temp4	=r18
;.def	Temp1	=r19
;.def	Temp2	=r20
;.def	Temp6	=r21

;.equ	tASCII0	=$64
;.equ	tASCII1	=$63
;.equ	tASCII2	=$62	;    
;.equ	tASCII3	=$61	;  
;.equ	tASCII4	=$60
;.equ	fASCIIL	=$64
;.equ	fASCIIH	=$65



bin2ASCII16:
	cli
	push	Temp1
	push	Temp2
	push	Temp3
	push	Temp4
	push	Temp5
	push	Temp6

	ldi	Temp6,0x30
	ldi2	Temp3,low(10000),Temp4,high(10000)	
	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ld	Temp2,Y
	ldd	Temp1,Y+1


	rcall	bin2ASCII_digit
	ldi2	YH,high(tASCII4),YL,low(tASCII4)
	add	Temp5,Temp6
	st	Y+,Temp5

	ldi2	Temp3,low(1000),Temp4,high(1000)
	rcall	bin2ASCII_digit
	add	Temp5,Temp6
	st	Y+,Temp5

	ldi2	Temp3,low(100),Temp4,high(100)
	rcall	bin2ASCII_digit
	add	Temp5,Temp6
	st	Y+,Temp5

	ldi2	Temp3,low(10),Temp4,high(10)
	rcall	bin2ASCII_digit
	add	Temp5,Temp6
	st	Y+,Temp5

	add	Temp2,Temp6
	st	Y,Temp2

	pop	Temp6
	pop	Temp5
	pop	Temp4
	pop	Temp3
	pop	Temp2
	pop	Temp1
	sei
	ret

bin2ASCII_digit:
	ldi	Temp5,-1

bin2ASCII_digit_loop:
	inc	Temp5
	sub	Temp2,Temp3
	sbc	Temp1,Temp4
	brsh	bin2ASCII_digit_loop
	add	Temp2,Temp3
	adc	Temp1,Temp4
	ret

;***********************************************************************

;***************************************************************************
;*
;* div32_32_32s - 32/32 Bit Signed Division

;     :
; : DataMat4-DataMat1(4 ), : DataMat8-DataMat5(4 )
; : : DataMat4-DataMat1(4 ), : DataMat8-DataMat5(4 )

;***************************************************************************

;***** Subroutine Register Variables
/*	Temp1		; 

	d32s		;sign register
	DataL		;remainder low byte
	DataML		;remainder low byte
	DataMH		;remainder low byte
	DataH		;remainder high byte

	Temp1		;result low byte
	Temp2		;result low byte
	Temp3		;result low byte
	Temp4		;result high byte

	Temp1		;dividend low byte
	Temp2		;dividend low byte
	Temp3		;dividend low byte
	Temp4		;dividend high byte

	Temp5		;divisor low byte
	Temp6		;divisor low byte
	XL		;divisor low byte
	XH		;divisor high byte

	YL		;loop counter
*/
;***** Code
div32_32_32s:
	push	DataH
	push	DataMH
	push	DataML
	push	DataL
	push	Temp1
	push	Temp2
	push	Temp3
	push	Temp4
	push	Temp5
	push	Temp6
	push	Tmp
	push	XH
	push	XL
	push	YL

	lds	Temp1,DataMat1
	lds	Temp2,DataMat2
	lds	Temp3,DataMat3
	lds	Temp4,DataMat4
	lds	Temp5,DataMat5
	lds	Temp6,DataMat6
	lds	XL,DataMat7
	lds	XH,DataMat8

	cpi	Temp5,0		;   0
	brne	d32s_7		; =0,
	cpi	Temp6,0		; DIV0=1
	brne	d32s_7		; DIV0=0
	cpi	XL,0
	brne	d32s_7
	cpi	XH,0
	brne	d32s_7
	rjmp	d32s_8

d32s_7:	mov	Tmp,Temp4		;move dividend High to sign register
	eor	Tmp,XH		;xor divisor High with sign register
	sbrs	Temp4,7		;if MSB in dividend set
	rjmp	d32s_1
	com	Temp4		;change sign of dividend
	com	Temp3		;change sign of dividend
	com	Temp2		;change sign of dividend
	com	Temp1		
	subi	Temp1,low(-1)
	sbci	Temp2,high(-1)
	sbci	Temp3,byte3(-1)
	sbci	Temp4,byte4(-1)
d32s_1:	sbrs	XH,7		;if MSB in divisor set
	rjmp	d32s_2
	com	Temp5		;change sign of divisor
	com	Temp6		;change sign of divisor
	com	XL		;change sign of divisor
	com	XH		
	subi	Temp5,low(-1)
	sbci	Temp6,high(-1)
	sbci	XL,byte3(-1)
	sbci	XH,byte4(-1)
d32s_2:	clr	DataL		;clear remainder Low byte
	clr	DataML		;clear remainder Low byte
	clr	DataMH		;clear remainder Low byte
	sub	DataH,DataH		;clear remainder High byte and carry
	ldi	YL,33		;init loop counter

d32s_3:	rol	Temp1		;shift left dividend
	rol	Temp2
	rol	Temp3
	rol	Temp4
	dec	YL		;decrement counter
	brne	d32s_5		;if done
	sbrs	Tmp,7		;if MSB in sign register set
	rjmp	d32s_4
	com	Temp1		;change sign of result
	com	Temp2
	com	Temp3
	com	Temp4
	subi	Temp1,low(-1)
	sbci	Temp2,high(-1)
	sbci	Temp3,byte3(-1)
	sbci	Temp4,byte4(-1)

d32s_4:	sts	DataMat1,Temp1
	sts	DataMat2,Temp2
	sts	DataMat3,Temp3
	sts	DataMat4,Temp4
	sts	DataMat5,DataL
	sts	DataMat6,DataML
	sts	DataMat7,DataMH
	sts	DataMat8,DataH

	clr	Tmp

d32s_8:	pop	YL
	pop	XL
	pop	XH
	pop	Tmp
	pop	Temp6
	pop	Temp5
	pop	Temp4
	pop	Temp3
	pop	Temp2
	pop	Temp1
	pop	DataL
	pop	DataML
	pop	DataMH
	pop	DataH

	ret			;return

d32s_5:	rol	DataL		;shift dividend into remainder
	rol	DataML
	rol	DataMH
	rol	DataH
	sub	DataL,Temp5		;remainder = remainder - divisor
	sbc	DataML,Temp6	;
	sbc	DataMH,XL		;
	sbc	DataH,XH		;
	brcc	d32s_6		;if result negative
	add	DataL,Temp5		;restore remainder
	adc	DataML,Temp6
	adc	DataMH,XL
	adc	DataH,XH
	clc			;clear carry to be shifted into result
	rjmp	d32s_3		;else
d32s_6:	sec			;set carry to be shifted into result
	rjmp	d32s_3

;******************************************************************************
;*
;* FUNCTION
;*	muls16x16_32
;* DECRIPTION
;*	Signed multiply of two 16bits numbers with 32bits result.
;* USAGE
;*	DataH:DataMH:DataML:DataL = DataH:DataL * DataMH:DataML
;* STATISTICS
;*	Cycles :	19 + ret
;*	Words :	15 + ret
;* NOTE
;*	The routine is non-destructive to the operands.
;*
; 1 : DataH:DataL(2 ), 2 : DataMH:DataML(2 )
; : DataH-DataMH-DataML-DataL(4 )

;******************************************************************************

muls16x16_32:
	push	Temp1
	push	Temp2
	push	Temp3
	push	Temp4
	push	Temp5
	push	Temp6
	push	Tmp

	clr	Tmp
	mov	Temp5,DataH
	mov	Temp6,DataMH
	muls	Temp5,Temp6		; (signed)ah * (signed)bh
	movw	Temp1,R0
	mul	DataL,DataML	; al * bl
	movw	Temp3,R0
	mov	Temp6,DataML
	mulsu	Temp5,Temp6		; (signed)ah * bl
	sbc	Temp2,Tmp
	add	Temp4,R0
	adc	Temp1,R1
	adc	Temp2,Tmp
	mov	Temp5,DataL
	mov	Temp6,DataMH
	mulsu	Temp6,Temp5		; (signed)bh * al
	sbc	Temp2,Tmp
	add	Temp4,R0
	adc	Temp1,R1
	adc	Temp2,Tmp

	mov	DataH,Temp2
	mov	DataMH,Temp1
	mov	DataML,Temp4	;
	mov	DataL,Temp3

	pop	Tmp
	pop	Temp6
	pop	Temp5
	pop	Temp4
	pop	Temp3
	pop	Temp2
	pop	Temp1

	ret

/********************************************************************************

calcul_B:		;B=k*U  - 32 
		; , :DataL,DataH-U, XL,XH-(K); : DataH-DataMH-DataML-DataL

	push	Temp1
	push	Temp2
	push	Temp3
	push	Temp4
	push	Temp5
	push	Temp6
	push	YL
	push	YH

	movw	YL,DataL		;  Y   U
	call	read_eeprom
	adiw	XL,1
	mov	DataML,Temp1
	call	read_eeprom		;   .-  DataMH:DataML
	adiw	XL,1
	mov	DataMH,Temp1
	rcall	muls16x16_32	;*U -> DataH:DataMH:DataML:DataL

	movw	Temp3,DataL		;  Temp4:Temp6:Temp5:Temp3
	movw	Temp5,DataML
	call	read_eeprom
	adiw	XL,1
	mov	DataML,Temp1	;   .-  DataMH:DataML
	call	read_eeprom
	adiw	XL,1
	mov	DataMH,Temp1
	movw	DataL,YL		;   U
	rcall	muls16x16_32	;*U -> DataH:DataMH:DataML:DataL

	sts	DataMat1,DataL
	sts	DataMat2,DataML
	sts	DataMat3,DataMH	; DataH:DataL*DataMH:DataML
	sts	DataMat4,DataH

	ldi	Temp1,low(_NumbDec)
	sts	DataMat5,Temp1
	ldi	Temp1,high(_NumbDec)	; 10000
	sts	DataMat6,Temp1
	clr	Temp1
	sts	DataMat7,Temp1
	sts	DataMat8,Temp1
	rcall	div32_32_32s	; *U     
	lds	DataL,DataMat1
	lds	DataML,DataMat2	;  DataH:DataMH:DataML:DataL
	lds	DataMH,DataMat3
	lds	DataH,DataMat4

	add	DataL,Temp3		;  K*U+*U/10000
	adc	DataML,Temp5
	adc	DataMH,Temp6
	adc	DataH,Temp4

	pop	YH
	pop	YL
	pop	Temp6
	pop	Temp5
	pop	Temp4
	pop	Temp3
	pop	Temp2
	pop	Temp1
	ret
*/
;------------------------

mul_16x8:			;/   16-   8-
		; - DataH:DataL,Temp1;  - DataH:DataL

	push	Temp3
	push	Temp4
	mul	DataL,Temp1		;    8-.,- R1:R0
	movw	Temp3,R0		; R1:R0  Temp4:Temp3
	mul	DataH,Temp1		;    8-.,- R1:R0
	add	Temp4,R0
	movw	DataL,Temp3
	pop	Temp4
	pop	Temp3
	ret

;-----------------------

mul_16x16_16:			;/   16-   16- 
		; - DataH:DataL,Temp1:Temp2;  - DataH:DataL

	push	Temp3
	push	Temp4
	mul	DataL,Temp2		; al * bl
	movw	Temp3,R0
	mul	DataH,Temp2		; ah * bl
	add	Temp4,R0
	mul	Temp1,DataL		; bh * al
	add	Temp4,R0
	movw	DataL,Temp3
	pop	Temp4
	pop	Temp3
	ret

;----------------------

inc_point_16:
	push	Temp1
	push	Temp2
	push	XL
	push	XH

	inc	Point
	ldi	Temp1,16
	cp	Point,Temp1
	brne	ir16_1
	clr	Temp1
	mov	Point,Temp1

ir16_1:	mov	DataL,Point
	clr	DataH
	ldi	Temp1,5
	rcall	mul_16x8
	ldi2	XL,low(_TPoint0),XH,high(_TPoint0)
	add	XL,DataL
	adc	XH,DataH
	rcall	copy_point

	pop	XH
	pop	XL
	pop	Temp2
	pop	Temp1
	ret

copy_point:		; X-
	push	Temp1
	push	Temp2
	push	ZL
	push	ZH

	ldi2	ZL,low(SetTimHour),ZH,high(SetTimHour)
	ldi	Temp2,5
ir16_2:	call	read_eeprom
	adiw	XL,1
	st	Z+,Temp1
	dec	Temp2
	brne	ir16_2

	pop	ZH
	pop	ZL
	pop	Temp2
	pop	Temp1
	ret

write_point:
	ldi2	XL,low(_TPoint0),XH,high(_TPoint0)
	mov	DataL,Point
	clr	DataH
	ldi	Temp1,5
	call	mul_16x8
	add	XL,DataL
	adc	XH,DataH
	ldi2	Temp3,low(SetTimHour),Temp2,high(SetTimHour)
	ld	Temp1,Z
	sub	ZL,Temp3
	sbc	ZH,Temp2
	add	XL,ZL
	adc	XH,ZH
	jmp	write_eeprom
