
;*****************************************************************************************************************
;		   "--"
;*****************************************************************************************************************

;!	    .    
;		  . .  readme.txt       .
;		     .     - 
;		.     ,    klotos@mail.ru      .
;-----------------------------------------------------------------------------------------------------------------


;   4     32768 


.include	"m16def.inc"
.include	"macros.inc"
.include	"def16.inc"


.CSEG
.ORG	0
	jmp	Reset
	jmp	ext_int0		;     1 (    )
	jmp	ext_int1		;     1 ( )
	jmp	tim2_comp		;       2
.ORG	OVF0addr
	jmp	tim_ovf0		;       0
.ORG	ADCCaddr
	jmp	adcc
.ORG	ACIaddr
	jmp	ana_comp
.ORG	OC0addr
	jmp	timer0_comp

reset:			; , 

	cli
	ldio	SPH,high(RAMEND)	;  
	ldio	SPL,low(RAMEND)	;  

	ldio	MCUCR,$43		;   (Idle)
	ldio	WDTCR,$f		;    2,2
;	in	Temp1,MCUCSR
;	sbrc	Temp1,WDRF
;	rjmp	ssl

	ldio	DDRB,(1<<PB0)+(1<<PB1)+(1<<PB4)	;  
	ldio	DDRC,(1<<PC2)+(1<<PC3)+(1<<PC4)+(1<<PC5);  C
	ldio	DDRD,(1<<PD4)+(1<<PD5)+(1<<PD6)+(1<<PD7);  D
	ldio	PORTD,(1<<PD2)+(1<<PD3)+(1<<PD4)+(1<<PD5);  D: D3,PD2 -  

	chns	MCUCSR,(1<<JTD)

	sei
	call	lcd_init

		; 

	ldi2	ZH,high(RAMEND-30),ZL,low(RAMEND-30)
	clr	Temp1
	ldi	Temp2,$60
clean_ram:	st	-Z,Temp1
	cp	ZL,Temp2
	cpc	ZH,Temp1
	brne	clean_ram

	ldi2	ZH,high(Day),ZL,low(Day)
	ldi	Temp1,1
	ldi	Temp2,2
set_ram:	st	Z+,Temp1
	dec	Temp2
	brne	set_ram
	ldi	Temp1,6
	sts	Year,Temp1
	ldi	Temp1,low(366)
	sts	TempTermL,Temp1
	ldi	Temp1,high(366)
	sts	TempTermH,Temp1
	ldi	Temp1, cTimeRead1W
	sts	CntRead1W, Temp1

	clr	Temp1
	sts	FlagsButton,Temp1
	out	Flags,Temp1
	out	FlagsLcd,Temp1
	clr	Second
	clr	Mode
	clr	Rate
	clr	Point
	SETB	FlagsLCD,SUM_ON
;	SETB	FlagsLCD,SOUND_BUT
ssl:	sei
	ldio	ASSR,(1<<AS2)	;    2
	ldio	OCR2,$7f		;  0,25 
	ldio	TCCR2,$c		;   
	sbi	PORTD,ButLight
as_wait:	in	Temp1,ASSR
	sbrc	Temp1,OCR2UB	;  
	rjmp	as_wait
	sbrc	Temp1,TCR2UB	;  
	rjmp	as_wait
	sbrc	Temp1,TCN2UB	;  
	rjmp	as_wait
	chns	TIFR,(1<<OCF2)+(1<<TOV2)
	chns	TIMSK,(1<<OCIE2)	;     2


	ldi	Temp1,high(_Min)
	sts	AdjustMem1H,Temp1
	ldi	Temp1,low(_Min)
	sts	AdjustMem1L,Temp1

	ldio	ADMUX,0b11000011	; . . .  2,56,   ADC3
	ldio	ADCSRA,$ce		; ,  ,  115
	chns	SFIOR,(1<<ADTS0)	;    

	sbi	ACSR,ACIE		;   

	chns	GICR,(1<<INT0)	;    

	sbi	PORTD,BackLight

	ldi	Temp1,ONEWIRE_18B20_CONVERT_T
	sts	Data1Wire,Temp1
	call	OneWire_SendCom	;   1-Wire  ConvertT

ssleep:

	SKBC	Flags,POWER_OFF	;   ,  
	rcall	power_handler
	wdr

	sleep

	wdr
	SKBC	Flags,POWER_OFF	;   ,  
	rcall	power_handler
	sbic	PIND,PowerInt	;    ,  
	rjmp	sslp1

	SKBC	FlagsLCD,ONEW_ON	;    ,  
	rcall	termo_handler

	SKBC	FlagsButton,BUT_ON	;   ,  
	rcall	button_handler

	ldi2	ZH,high(ind_mode),ZL,low(ind_mode); -   
	clr	Temp1
	add	ZL,Mode
	adc	ZH,Temp1		;    
	icall			;  /  Z

	SKBC	FlagsLCD,LCD_COM	;      ,  
	rcall	lcd_com_handler

	SKBC	Flags,SOUND_ON	;    ,  
	rcall	beep_handler

/*	lds	Temp1,FlagsRAM
	sbrs	Temp1,BACKLIGHT_AUTO	;    ,  
	rjmp	sslp1
	lds	Temp1,DataFotoL
	lds	Temp2,DataFotoH
	lds	Temp3,DataFotoTrL
	lds	Temp4,DataFotoTrH
	cp	Temp1,Temp3
	cpc	Temp2,Temp4
*/

sslp1:	SKBC	Flags,TIM_SECOND	;      ,  
	rcall	time_handler



;  

	rjmp	ssleep

termo_handler:			;     

	CLRB	FlagsLCD, ONEW_ON
	jmp	OneWire_ReadData	;   

beep_handler:			;   

	SKBC	Flags,BEEPING
	ret

	SETB	Flags,BEEPING
	ldio	ADCSRA,0b00101111	; 

	lds	Temp1,NumbNoteMemL
	lds	Temp2,NumbNoteMemH
	tst	Temp2
	brne	next		; NumbNoteMemH<>0, 
	tst	Temp1
	brne	next

begin_melody:	;    

	ldi2	ZL,low(mymelody*2),ZH,high(mymelody*2)
	sts	MelodyBeginL,ZL	;  
	sts	MelodyBeginH,ZH
	SKBS	FlagsLCD,SOUND_SHORT	;  , 
	lds	Temp1,NumbMelody
	SKBC	FlagsLCD,SOUND_SHORT	;   , 
	ldi	Temp1,_NumbMelShort
	cpi	Temp1,$ff		;  ,
	breq	dis_melody		; 
	tst	Temp1		;  =0
	breq	monotonous		; 
	cpi	Temp1,1		;  =1
	breq	next2		; 
	dec	Temp1
			;    
find:	lpm	Temp2,Z+		;  Temp2   Z
	cpi	Temp2,$ff		; <>ff,
	brne	find		; 
	adiw	ZL,1
	dec	Temp1
	brne	find
	sts	MelodyBeginL,ZL	;  
	sts	MelodyBeginH,ZH
	rjmp	next2

dis_melody:
	CLRB	Flags,BEEPING
	CLRB	Flags,SOUND_ON
	ret

monotonous:	
	lds	Temp1,FlagsRAM
	sbrc	Temp1,TEST_MELODY	;  ,  
	ret
	ldio	OCR0,$3e		; 1000 
	ldio	TCNT0,0
	chns	TIFR,(1<<OCF0)+(1<<TOV0)
	ldio	TCCR0,$b		;=64,   
	chns	TIMSK,(1<<OCIE0)	;      0
	ret

next:
	lds	ZL,NumbNoteMemL
	lds	ZH,NumbNoteMemH
next2:
	lpm	Temp1,Z+		;Temp1 = nota
	cpi	Temp1,$ff		;   ,
	brne	no_end_melody	; 
	lds	Temp1,FlagsRAM
	sbrc	Temp1,TEST_MELODY	;  ,  
	rjmp	stop_melody
	SKBC	FlagsLCD,SOUND_SHORT	;   , 
	rjmp	stop_melody
	lds	ZL,MelodyBeginL
	lds	ZH,MelodyBeginH
	rjmp	next2
no_end_melody:
	lpm	Temp2,Z+		;Temp2 = dlit
	sts	NumbNoteMemL,ZL
	sts	NumbNoteMemH,ZH

	cpi	Temp1,$fe		; -,
	breq	note_pause		; 

	ldi2	XL,low(notes),XH,high(notes)
	add	XL,Temp1
	clr	Temp1
	adc	XH,Temp1
	call	read_eeprom
	out	OCR0,Temp1		;  

	ldio	TCNT0,0
	chns	TIFR,(1<<OCF0)+(1<<TOV0)
	ldio	TCCR0,$b		;=64,   
	chns	TIMSK,(1<<OCIE0)	;      0
note_pause:
	ldi	Temp1,_TimeDlitNote
	mul	Temp1,Temp2		;   
	sts	CntBeep,R0		;    ( )
	SETB	FlagsRAM,SOUND_PAUSE	;    
	ret

stop_melody:
	CLRB	Flags,BEEPING
	CLRB	Flags,SOUND_ON
	lds	Temp1,FlagsRAM
	cbr	Temp1,(1<<SOUND_PAUSE)+(1<<TEST_MELODY)
	sts	FlagsRAM,Temp1
	CLRB	FlagsLCD,SOUND_SHORT
	ldio	TCCR0,0
	chnc	TIMSK,(1<<OCIE0)
	cbi	PORTB,ZP
	clr	Temp1
	sts	NumbNoteMemL,Temp1
	sts	NumbNoteMemH,Temp1
	sts	CntBeep,Temp1
	ldio	ADCSRA,$ce		; ,  ,  115
	ret


lcd_com_handler:		;    

	SKBC	Flags,BEEPING
	ret
	SKBC	FlagsButton,BUT_ON
	ret
	lds	LcdDataOut,LcdComWrite
	call	lcd_com_write
	call	lcd_del40
	ret

power_handler:			;   

	cli
	CLRB	Flags,POWER_OFF	;   
	sbis	PIND,PowerInt	;    ,  
	rjmp	power_wake

	ldio	MCUCR,$70		;   (PowerSave)    
	call	dis_int_sb		;   
	cbi	ACSR,ACIE		;   
	sbi	ACSR,ACD		; 
	chnc	TIMSK,(1<<TOIE0)	;    0
	chns	SFIOR,(1<<PSR10)	;  1   0
	chns	GICR,(1<<INT0)	;    
	ldio	DDRB,0		;  
	out	PORTB,Temp1
	out	DDRC,Temp1		;  C
	out	PORTC,Temp1
	out	DDRD,Temp1		;  D
	ldio	PORTD,(1<<PowerInt)	;      
	sei
	ret

power_wake:			;     

	ldio	MCUCR,$43		;   (Idle)    
	chns	TIMSK,(1<<TOIE0)	;    0
	ldio	DDRB,(1<<PB0)+(1<<PB1)+(1<<PB4)	;  
	ldio	DDRC,(1<<PC2)+(1<<PC3)+(1<<PC4)+(1<<PC5);  C
	ldio	DDRD,(1<<PD4)+(1<<PD5)+(1<<PD6)+(1<<PD7);  D
	ldio	PORTD,(1<<PD2)+(1<<PD3)+(1<<PD4)+(1<<PD5);  D: D3,PD2 -  
	call	en_int_sb		;   
	cbi	ACSR,ACD		; 
	sbi	ACSR,ACIE		;   
	chns	GICR,(1<<INT0)	;    
	sbi	PORTD,BackLight
	ldi	Temp1,$44
	sts	Data1Wire,Temp1
	call	OneWire_SendCom	;   1-Wire  ConvertT
	sei
	jmp	lcd_init

thdret:
;	SKBS	Flags,BEEPING	;  ,    
;	call	lcd_init2
	sbic	PIND,PowerInt	;    ,  
	ret
	SKBC	Flags,BEEPING
	ret
	call	lcd_ram_out
	ret

thdstret2:	rjmp	thdstret

time_handler:			;   

	CLRB	Flags,TIM_SECOND
	sbic	PIND,PowerInt	;    ,  
	rjmp	thdl11

	lds	Temp1,CntHoldInd
	tst	Temp1		; 
	breq	thdl12		;  =0,  
	dec	Temp1
	brne	thdl12		; <>0,  
	call	set_mode_0
	clr	Rate
thdl12:	sts	CntHoldInd,Temp1

	lds	Temp1,CntLightOff	;   
	tst	Temp1
	breq	thdl11
	lds	XL,AdjustMem1L
	lds	XH,AdjustMem1H
	ldi	Temp1,high(_Max)
	sbiw	XL,2
	cpi	XL,low(_Max)
	cpc	XH,Temp1
	brlo	thdl11
	sts	AdjustMem1L,XL
	sts	AdjustMem1H,XH

thdl11:
/*	SKBC	Flags,SOUND_ON	;    ,  
	rjmp	thdl15
	lds	Temp1,CntRead1W	;   
	dec	Temp1
	sts	CntRead1W,Temp1
	brne	thdl15
	ldi	Temp1,cTimeRead1W
	sts	CntRead1W,Temp1
	call	OneWire_ReadData	;   
	*/

thdl15:	mov	Temp1,Second
	cpi	Temp1,240		;  =60?
	brne	thdret		; -   /
				; - 

	sbic	PIND,PowerInt	;    ,  
	rjmp	thdll2

	lds	Temp2,FlagsRAM
	sbrs	Temp2,TIMER_LAMP	;   ,  
	rjmp	thdll8
	lds	Temp1,TimerLampTemp
	dec	Temp1
	brne	thdll1
	CLRB	Flags,LAMP_ON
	cbr	Temp2,(1<<TIMER_LAMP)
	sts	FlagsRAM,Temp2
	lds	Temp1,TimerLamp
thdll1:	sts	TimerLampTemp,Temp1

thdll8:	lds	Temp1,CntLightOff
	tst	Temp1		; 
	breq	thdll2		;  =0,  
	dec	Temp1
	brne	thdl13		; <>0,  
	SKBC	Flags,LAMP_ON	;  , 
	call	onoff_lamp
thdl13:	sts	CntLightOff,Temp1

thdll2:	clr	Temp1
	mov	Second,Temp1
	ldi2	ZH,high(Minute),ZL,low(Minute)	; - 
	ld	Temp1,Z
	inc	Temp1		; 
	cpi	Temp1,60		;  =60?
	breq	thdll21		;  - 
	rjmp	thdstret		; -   /

thdll21:	sbic	PIND,PowerInt	;    ,  
	rjmp	thdl3

	SKBS	FlagsLCD,SOUND_HOUR	;    ,  
	rjmp	thdl3
	ldi	Temp1,_TimSoundHour
	sts	CntBeep,Temp1
	SETB	Flags,BEEPING
	ldio	OCR0,$3e		; 1000 
	ldio	TCNT0,0
	chns	TIFR,(1<<OCF0)+(1<<TOV0)
	ldio	TCCR0,$b		;=64,   
	chns	TIMSK,(1<<OCIE0)	;      0

thdl3:	clr	Temp1
	st	Z+,Temp1		; , - 
	ld	Temp1,Z
	inc	Temp1		; 

		;    /

	SKBS	FlagsLCD,SUM_ON	;   /  ,  
	rjmp	thds1
	cpi	Temp1,2		;  =2?
	brne	thds1
	lds	Temp2,NameDays
	cpi	Temp2,6		; -?
	brne	thds1
	push	ZL
	push	ZH
	ldi2	ZH,high(date*2),ZL,low(date*2); -     
	lds	Temp2,Month		;  
	clr	Temp3
	add	ZL,Temp2		;    
	adc	ZH,Temp3		;Temp3=0
	lpm	Temp3,Z		;    .
	lds	Temp4,Day		;  
	pop	ZH
	pop	ZL
	subi	Temp3,7		;  
	cp	Temp4,Temp3		;   <     ,
	brlt	thds1		; 
	cpi	Temp2,3		;-?
	breq	thds2		;-
	cpi	Temp2,10		;-?
	brne	thds1		;-
	SKBC	FlagsButton,SUM_DEC	;     , 
	rjmp	thdsc
	dec	Temp1		; 
	SETB	FlagsButton,SUM_DEC
	rjmp	thds1

thds2:	inc	Temp1		; 

thdsc:	CLRB	FlagsButton,SUM_DEC
thds1:	cpi	Temp1,24		;  =24?
	brne	thdstret		; -   /
				; - 
	clr	Temp1
	st	Z+,Temp1		; , -  
	ld	Temp1,Z		;  
	inc	Temp1		;  
	cpi	Temp1,7		;  =7 (0-6)?
	brne	thd2		;
				;
	clr	Temp1
thd2:	st	Z+,Temp1		;  , - 
	clr	Temp1
	movw	YL,ZL
	ldi2	ZH,high(date*2),ZL,low(date*2); -     
	ldd	Temp2,Y+1		;  
	add	ZL,Temp2		;    
	adc	ZH,Temp1		;Temp1=0
	lpm	Temp3,Z		;    .
	ld	Temp1,Y		;  
	movw	ZL,YL
	cpi	Temp2,2		; - ?
	brne	thd1		;
				;
	ldd	Temp2,Z+2		;  
	andi	Temp2,3		;   
	brne	thd1		;   ,  
	inc	Temp3		; 29- 
thd1:	inc	Temp1		; 
	cp	Temp1,Temp3		;  = X ?
	brne	thdstret		; -   /
				; - 
	ldi	Temp1,1
	st	Z+,Temp1		; , - 
	ld	Temp1,Z		;  
	inc	Temp1		; 
	cpi	Temp1,13		;  =13?
	brne	thdstret		; -   /
				; - 
	ldi	Temp1,1
	st	Z+,Temp1		; , - 
	ld	Temp1,Z
	inc	Temp1		;  ( 2256 )

thdstret:	st	Z,Temp1

	sbic	PIND,PowerInt	;    ,  
	rjmp	thdret
	call	lcd_init

		;  

	ldi2	ZH,high(AlrContr32),ZL,low(AlrContr32)
	ldi	Temp4,3
alr_hnd4:	ldi2	YH,high(Day),YL,low(Day)
	ld	Temp2,-Z		;  
	sbrc	Temp2,ALR_ON	;    ,  
	rjmp	alr_hnd5
	sbiw	ZL,4
	rjmp	alr_hnd1

alr_hnd5:	ld	Temp1,-Z		;    
	ld	Temp3,-Y		;   
	cpi	Temp1,7
	breq	alr_hnd2		;    ,  
	cpi	Temp1,8		;      (-),  
	brne	alr_hnd51
	cpi	Temp3,5		;   =-,   
	brlo	alr_hnd2
	rjmp	alr_hnd1		;- 

alr_hnd51:	cp	Temp1,Temp3
	breq	alr_hnd2		; ,  
	sbiw	ZL,3
	rjmp	alr_hnd1

alr_hnd2:	sbiw	ZL,2		; -  
	ld	Temp1,Z+		;   
	ld	Temp3,-Y		;  
	cp	Temp1,Temp3
	breq	alr_hnd6		; ,  
	sbiw	ZL,2
	rjmp	alr_hnd1

alr_hnd6:	ld	Temp1,Z		;   
	ld	Temp3,-Y		;  
	cp	Temp1,Temp3
	breq	alr_hnd7		; ,  
	sbiw	ZL,2
	rjmp	alr_hnd1

alr_hnd7:	SETB	Flags,ALARM_ON	;   
	sbiw	ZL,2		; -       
	sbrs	Temp2,ALR_LAMP_ON	;   ,  
	rjmp	alr_hnd3
	CLRB	Flags,LAMP_ON	;  ( ,   ,  )
	call	onoff_lamp		; 
	ldi	Temp1,_TimLampOff	;   
	sts	CntLightOff,Temp1

alr_hnd3:	ldd	Temp1,Z+5		;  
	sbrc	Temp2,ALR_SEARCH_ON	;   ,  
	inc	Temp1
	sbrs	Temp2,ALR_MUS_ON	;   ,  
	ser	Temp1
	sbrc	Temp2,ALR_MUS_ON	;   ,  
	std	Z+5,Temp1
	sts	NumbMelody,Temp1
	SETB	Flags,SOUND_ON
	ldi	Temp1,_TimSoundAlr
	sts	CntHoldInd,Temp1

	ldi	Temp1,high(_Min)
	sts	AdjustMem1H,Temp1
	ldi	Temp1,low(_Min)
	sts	AdjustMem1L,Temp1

	ldi	Temp1,4
	mov	Mode,Temp1

alr_hnd1:	dec	Temp4
	breq	alr_hnd111
	rjmp	alr_hnd4
alr_hnd111:
	lds	Temp1,TimerLoadFlag
	sbrc	Temp1,TIM_ONE_EN
	rjmp	tmld_one
	sbrc	Temp1,TPROG_EN
	rjmp	tmld_pr
	sbrc	Temp1,TSTAT_EN
	rjmp	tmld_st
tmld_ret:	rjmp	thdret

tmld_one:
	lds	Temp1,TimerLoadHour
	tst	Temp1
	breq	tmldone_3
	dec	Temp1
	sts	TimerLoadHour,Temp1
	brne	tmld_ret
tmldone_3:	lds	Temp1,TimerLoadMin
	tst	Temp1
	breq	tmld_ret
	dec	Temp1
	sts	TimerLoadMin,Temp1
	brne	tmld_ret

	lds	Temp2,TimerLoadFlag
	sbrc	Temp2,TIM_LOAD_CYCLE
	rjmp	tmldone_1
	cbr	Temp2,(1<<TIM_ONE_EN)
	sbrc	Temp2,TIM_LOAD_ONOFF
	rjmp	tmldone_2
	call	load_off		; , .
	sts	TimerLoadFlag,Temp2
	rjmp	thdret

tmldone_2:	call	load_onn		; , .
	sts	TimerLoadFlag,Temp2
	rjmp	thdret

tmldone_1:	call	onoff_load
	lds	Temp1,TimerLoadHourMem
	sts	TimerLoadHour,Temp1
	lds	Temp1,TimerLoadMinMem
	sts	TimerLoadMin,Temp1
	rjmp	thdret

thdret_22:	CLRB	Flags,NEGATIVE
	rjmp	thdret
tmld_st:
	ldi2	ZL,low(DataTerm3L),ZH,high(DataTerm3L)
	call	termo_conv
	SKBC	Flags,NEGATIVE
	rjmp	thdret_22
	lds	Temp5,SetTermostatL
	lds	Temp6,SetTermostatH
	lds	Temp1,TimerLoadFlag
	cp	DataL,Temp5
	cpc	DataML,Temp6
	sbrs	Temp1,TSTAT_ONOFF
	rjmp	tmldst_1		; 
	brlo	tmldst_2
	call	load_off		; 
	rjmp	thdret
tmldst_2:	call	load_onn		; 
	rjmp	thdret
tmldst_1:	brlo	tmldst_3
	call	load_onn		; 
	rjmp	thdret
tmldst_3:	call	load_off		; 
tmld_ret2:	rjmp	thdret

tmld_pr:
	mov	Temp1,Mode
	cpi	Temp1,20
	breq	tmld_ret2
	clr	Point
	ldi2	XL,low(_TPoint0+2),XH,high(_TPoint0+2);   

tmld_loop:	call	read_eeprom		;  
	mov	Temp3,Temp1
	sbrc	Temp1,7
	rjmp	tmld_pr_31		; 
	adiw	XL, 5		; 
	rjmp	tmld_pr_1

tmld_pr_31:	lds	Temp2,NameDays	;   
	andi	Temp1,$1f
	cpi	Temp1,7		;  ?
	breq	tmld_pr_2		;-
	cpi	Temp1,8		;  ?
	brne	tmld_pr_3		;-
	cpi	Temp2,5
	brlo	tmld_pr_2		; ,( )
tmld_pr_32:	adiw	XL, 5
	rjmp	tmld_pr_1		; - .  (- )

tmld_pr_3:	cp	Temp1,Temp2		; . != .
	brne	tmld_pr_32		; . (- )

tmld_pr_2:	sbiw	XL,2		;  
	call	read_eeprom
	lds	Temp2,Hour		;  
	cp	Temp1,Temp2
	breq	tmld_pr_6
	adiw	XL,7
	rjmp	tmld_pr_1		;   ,.(-)

tmld_pr_6:	adiw	XL,1		;  
	call	read_eeprom
	lds	Temp2,Minute	;  
	cp	Temp1,Temp2
	breq	tmld_pr_7
	adiw	XL,6
	rjmp	tmld_pr_1		;   ,.(-)

tmld_pr_7:	sbrs	Temp3,6		;?
	rjmp	tmld_pr_4		;
	call	onoff_load
	rjmp	tmld_pr_5
tmld_pr_4:	sbrc	Temp3,5		;?
	call	load_onn		; 
	sbrs	Temp3,5		;?
	call	load_off		; 

tmld_pr_5:	adiw	XL,2		;  
	call	read_eeprom
	sts	Adjust2L,Temp1
	adiw	XL,1
	call	read_eeprom
	sts	Adjust2H,Temp1
	adiw	XL,3

tmld_pr_1:	ldi	Temp1,16
	inc	Point
	cp	Point,Temp1
	breq	tmld_ret23
	rjmp	tmld_loop
tmld_ret23:	rjmp	thdret


/*lcd_handler:			;   0    

	SKBC	Flags,BEEPING
	ret
	SKBS	FlagsLCD,LCD_TIM_ON	;  0   ,  
	call	lcd_ram_out
*/bth1:	ret


button_handler:			;  

	lds	Temp1,CntBut
	tst	Temp1		;    0
	brne	bth1		;  <>0,  
	SKBC	FlagsButton,BUT_BOUN	;  BUT_BOUN ,  
	rjmp	but_h

	clr	LcdDataOut
	call	lcd_data_conv
	cbi	LcdPortSignOut,LcdOutRS
	sbic	PIND,SbIn		;   ,  
	rjmp	bth4

;			;  

	clr	Temp1
	sbi	LcdPortSignOut,LcdOutRS
	ldi	LcdDataOut,14
	call	lcd_data_conv
	sbis	PIND,SbIn		;      ,  
	ldi	Temp1,1
	ldi	LcdDataOut,13
	call	lcd_data_conv
	sbis	PIND,SbIn		;      ,  
	ldi	Temp1,2
	ldi	LcdDataOut,11
	call	lcd_data_conv
	sbis	PIND,SbIn		;      ,  
	ldi	Temp1,3
	ldi	LcdDataOut,7
	call	lcd_data_conv
	sbis	PIND,SbIn		;      ,  
	ldi	Temp1,4
	cbi	LcdPortSignOut,LcdOutRS
	ldi	LcdDataOut,15
	call	lcd_data_conv
	sbis	PIND,SbIn		;      ,  
	ldi	Temp1,5
	lds	Temp2,FlagsButton
	andi	Temp2,$f8		;    
	or	Temp2,Temp1		;    
	sts	FlagsButton,Temp2

		;      

	clr	Temp1
	sts	CntHoldInd,Temp1	; ,     
	CLRB	FlagsLCD,LCD_COM

	ldi2	ZH,high(work_mode),ZL,low(work_mode); -      
	mov	DataL,Mode
	mov	DataH,Temp1
	ldi	Temp1,5		;    5
	call	mul_16x8
	add	ZL,DataL
	adc	ZH,DataH		;    
	lds	Temp1,FlagsButton
	andi	Temp1,7		;   
	dec	Temp1
	clr	Temp2
	add	ZL,Temp1
	adc	ZH,Temp2		;    
	icall			;  Z

	SKBC	FlagsButton,MULTI
	rjmp	btth11
	SKBS	FlagsLCD,SOUND_BUT
	rjmp	btth11
	ldi	Temp1,_TimSoundBut
	sts	CntBeep,Temp1
	SETB	Flags,BEEPING
	ldio	OCR0,$3e		; 1000 
	ldio	TCNT0,0
	chns	TIFR,(1<<OCF0)+(1<<TOV0)
	ldio	TCCR0,$b		;=64,   
	chns	TIMSK,(1<<OCIE0)	;      0

btth11:	clr	LcdDataOut
	call	lcd_data_conv
	cbi	LcdPortSignOut,LcdOutRS
bth3:	sbic	PIND,SbIn		;    ,  
	rjmp	bth4
	SKBS	FlagsButton,MULTI	;   ,  
	rjmp	bth3

	SKBS	FlagsButton,MULTI_CNT	;   ,  
	rjmp	bth5
	lds	Temp1,CntButSet
	tst	Temp1		;   0
	brne	bth3		;  <>0,  
	ldi	Temp1,_TimCntSet
	sts	CntButSet,Temp1	;  CntButSet	
	rjmp	bth5

bth4:	CLRB	FlagsButton,MULTI_CNT
	CLRB	FlagsButton,MULTI
	clr	Temp1
	sts	CntButDelay,Temp1

bth5:	ldi	Temp1,_TimBoun
	sts	CntBut,Temp1	;  CntBut
	SETB	FlagsButton,BUT_BOUN;  BUT_BOUN
	ret

but_h:			;      
	SKBC	FlagsButton,MULTI_CNT
	rjmp	bth_222
	clr	Temp1
	sts	FlagsButton,Temp1
bth_222:	CLRB	FlagsButton,BUT_BOUN
	CLRB	FlagsButton,0
	CLRB	FlagsButton,1
	CLRB	FlagsButton,2
	CLRB	FlagsButton,BUT_ON
	jmp	en_int_sb		;   


ind_mode:			;    

	rjmp	ind_mode0
	rjmp	ind_mode1
	rjmp	ind_mode2
	rjmp	ind_mode3
	rjmp	ind_mode4
	rjmp	ind_mode5
	rjmp	ind_mode6
ret;	rjmp	ind_mode7
	rjmp	ind_mode8
	rjmp	ind_mode9
	rjmp	ind_mode10
	rjmp	ind_mode11
	rjmp	ind_mode12
	rjmp	ind_mode13
	rjmp	ind_mode14
	rjmp	ind_mode15
	rjmp	ind_mode16
	rjmp	ind_mode17
	rjmp	ind_mode18
	rjmp	ind_mode19
	rjmp	ind_mode20
	rjmp	ind_mode21
	rjmp	ind_mode22
	rjmp	ind_mode23
	rjmp	ind_mode24
	rjmp	ind_mode25
	rjmp	ind_mode26
	rjmp	ind_mode27
	rjmp	ind_mode28
	rjmp	ind_mode29
	rjmp	ind_mode30
	rjmp	ind_mode31
	rjmp	ind_mode32
	rjmp	ind_mode33
	rjmp	ind_mode34
	rjmp	ind_mode35
	rjmp	ind_mode36
	rjmp	ind_mode37
	rjmp	ind_mode38
	rjmp	ind_mode39
	rjmp	ind_mode40
	rjmp	ind_mode41
	rjmp	ind_mode42
	rjmp	ind_mode43
	rjmp	ind_mode44
	rjmp	ind_mode45
	rjmp	ind_mode46


;********************************* /      **************************


ind_mode0:			;   0

	call	ind_time

	SKBC	Flags,LOAD_ON
	rjmp	indm04

indm05:	ldi2	ZH,high(street*2),ZL,low(street*2)
	call	write_vr_2line

	ldi2	ZH,high(DataTerm2L),ZL,low(DataTerm2L)
	call	termo_conv
	ldi2	ZH,high(LcdRAM2+9),ZL,low(LcdRAM2+9)

	SKBC	FlagsTermo, TERMO_DAT2
	rjmp	nou_dat

	SKBS	Flags,NEGATIVE	; <0,  
	rjmp	indm01
	ldi	Temp1,'-'
	st	Z+,Temp1		;    ""
	CLRB	Flags,NEGATIVE
	rjmp	indm02
nou_dat:
	adiw	ZL,1
	ldi	Temp1,4
	ldi	Temp2,$f8
ndt1:	st	Z+,Temp2
	dec	Temp1
	brne	ndt1
	ret

indm01:	adiw	ZL,1
indm02:	ldi2	YH,high(tASCII3),YL,low(tASCII3)
	ld	Temp1,Y+
	cpi	Temp1,'0'
	brne	indm03		;   <>0,  
	ldi	Temp1,' '
indm03:	st	Z+,Temp1		;  
	ld	Temp1,Y+
	st	Z+,Temp1		;  
	ldi	Temp1,','
	st	Z+,Temp1		;
	ld	Temp1,Y+
	st	Z+,Temp1		;  
	ret
indm04:	sbrc	Second,2
	rjmp	indm05
	ldi2	ZH,high(mes_load_on*2),ZL,low(mes_load_on*2)
	jmp	write_vr_2line

ind_mode1:			;   1

	ldi2	ZH,high(tim_lamp*2),ZL,low(tim_lamp*2)
	call	write_videoram

	lds	Temp1,TimerLampTemp
	sts	fASCIIL,Temp1
	clr	Temp1
	sts	fASCIIH,Temp1
	call	bin2ASCII16
	ldi2	ZH,high(LcdRAM2+1),ZL,low(LcdRAM2+1)
	ldi2	YH,high(tASCII2),YL,low(tASCII2)
	ld	Temp1,Y+
	cpi	Temp1,'0'
	brne	indm1_1		;   <>0,  
	ldi	Temp1,' '
indm1_1:	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	lds	Temp1,FlagsRAM
	sbrc	Temp1,TIMER_LAMP	;   ,  
	ret
	ldi2	ZH,high(LcdRAM2+12),ZL,low(LcdRAM2+12)
	ldi	Temp1,'B'
	st	Z+,Temp1
	ldi	Temp1,$ae
	st	Z+,Temp1
	ldi	Temp1,'K'
	st	Z+,Temp1
	ldi	Temp1,$a7
	st	Z+,Temp1
	ret


ind_mode2:			;   2

	call	ind_time
	ldi2	ZH,high(pow_load*2),ZL,low(pow_load*2)
	call	write_vr_2line

	SKBS	Flags,LOAD_ON	;  ,  
	rjmp	indm22

	ldi2	ZH,high(Adjust2H),ZL,low(Adjust2H)
	call	NN_power
	ldi2	ZH,high(LcdRAM2+11),ZL,low(LcdRAM2+11)
	ldi2	YH,high(tASCII2),YL,low(tASCII2)
	ld	Temp1,Y+
	cpi	Temp1,'0'
	brne	indm21		;   <>0,  
	ldi	Temp1,' '
indm21:	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ret

indm22:
	ldi2	ZH,high(LcdRAM2+11),ZL,low(LcdRAM2+11)

	ldi	Temp1,'B'
	st	Z+,Temp1
	ldi	Temp1,$ae
	st	Z+,Temp1
	ldi	Temp1,'K'
	st	Z+,Temp1
	ldi	Temp1,$a7
	st	Z+,Temp1
	ret


ind_mode3:			;   3

	call	ind_time
	ldi2	ZH,high(temp_1_3*2),ZL,low(temp_1_3*2)
	call	write_vr_2line

	clr	Temp5
	sbrc	Second, 2
	rjmp	indm322
	ldi2	ZH,high(DataTerm1L),ZL,low(DataTerm1L)
	ldi	Temp6, '1'
	SKBC	FlagsTermo, TERMO_DAT1
	ser	Temp5
	rjmp	indm321

indm322:	ldi2	ZH,high(DataTerm3L),ZL,low(DataTerm3L)
	ldi	Temp6, '3'
	SKBC	FlagsTermo, TERMO_DAT3
	ser	Temp5

indm321:	call	termo_conv
	ldi2	ZH,high(LcdRAM2+7),ZL,low(LcdRAM2+7)
	st	Z, Temp6
	adiw	ZL, 2
	tst	Temp5
	brne	nou_dat3

	SKBS	Flags,NEGATIVE	; <0,  
	rjmp	indm31
	ldi	Temp1,'-'
	st	Z+,Temp1		;    ""
	CLRB	Flags,NEGATIVE
	rjmp	indm32

indm31:	adiw	ZL,1
indm32:	ldi2	YH,high(tASCII3),YL,low(tASCII3)
	ld	Temp1,Y+
	cpi	Temp1,'0'
	brne	indm33		;   <>0,  
	ldi	Temp1,' '
indm33:	st	Z+,Temp1		;  
	ld	Temp1,Y+
	st	Z+,Temp1		;  
	adiw	ZL, 1
	ld	Temp1,Y+
	st	Z+,Temp1		;  
	ret

nou_dat3:
	adiw	ZL,1
	ldi	Temp2,$f8
	st	Z+,Temp2
	st	Z+,Temp2
	st	Z+,Temp2
	st	Z,Temp2
	ret

ind_mode4:			;   4

	ldi2	ZH,high(alarm_beep*2),ZL,low(alarm_beep*2)
	jmp	write_videoram

ind_mode5:			;   5

	call	ind_time
	ldi2	ZH,high(pow_lamp*2),ZL,low(pow_lamp*2)
	call	write_vr_2line

	SKBS	Flags,LAMP_ON		;  ,  
	rjmp	inmd52

	ldi2	ZH,high(Adjust1H),ZL,low(Adjust1H)
	call	NN_power
	ldi2	ZH,high(LcdRAM2+12),ZL,low(LcdRAM2+12)
	ldi2	YH,high(tASCII2),YL,low(tASCII2)
	ld	Temp1,Y+
	cpi	Temp1,'0'
	brne	indm51		;   <>0,  
	ldi	Temp1,' '
indm51:	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ret

inmd52:
	ldi2	ZH,high(LcdRAM2+12),ZL,low(LcdRAM2+12)

	ldi	Temp1,'B'
	st	Z+,Temp1
	ldi	Temp1,$ae
	st	Z+,Temp1
	ldi	Temp1,'K'
	st	Z+,Temp1
	ldi	Temp1,$a7
	st	Z+,Temp1
	ret

ind_mode6:			;   6

	ldi2	ZH,high(bat_warning*2),ZL,low(bat_warning*2)
	call	write_videoram
	ldi2	ZH,high(DataVolt3L),ZL,low(DataVolt3L)
	ld	DataL,Z+
	ld	DataH,Z		;     3
	movw	Temp1,DataL
	lsr	Temp2
	ror	Temp1		;  2
	add	DataL,Temp1
	adc	DataH,Temp2		;  -   1,5
	ldi	Temp1,25
	call	mul_16x8		;  25
	ldi2	ZH,high(fASCIIL),ZL,low(fASCIIL)
	st	Z+,DataL		;   
	st	Z,DataH
	call	bin2ASCII16
	ldi2	ZH,high(LcdRAM2+11),ZL,low(LcdRAM2+11)
	ldi2	YH,high(tASCII4),YL,low(tASCII4)
	ld	Temp1,Y+
	st	Z+,Temp1
	adiw	ZL,1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y
	st	Z,Temp1
	ret

ind_mode7:			;   7

	ldi2	ZH,high(period_cal*2),ZL,low(period_cal*2)
	jmp	write_videoram


ind_mode8:			;   8

	ldi2	ZH,high(menu*2),ZL,low(menu*2)
	call	write_vr_1line
	ldi2	ZH,high(set_alm_clocks*2),ZL,low(set_alm_clocks*2)
	jmp	write_vr_2line

ind_mode9:			;   9

	ldi2	ZH,high(sel_alm_clock*2),ZL,low(sel_alm_clock*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM1+15),ZL,low(LcdRAM1+15)
	ldi	Temp1,'1'
	st	Z,Temp1
	ldi2	ZH,high(AlrHr1),ZL,low(AlrHr1)
	jmp	ind_alarm

ind_mode10:			;   10

	ldi2	ZH,high(sel_alm_clock*2),ZL,low(sel_alm_clock*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM1+15),ZL,low(LcdRAM1+15)
	ldi	Temp1,'2'
	st	Z,Temp1
	ldi2	ZH,high(AlrHr2),ZL,low(AlrHr2)
	jmp	ind_alarm

ind_mode11:			;   11

	ldi2	ZH,high(sel_alm_clock*2),ZL,low(sel_alm_clock*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM1+15),ZL,low(LcdRAM1+15)
	ldi	Temp1,'3'
	st	Z,Temp1
	ldi2	ZH,high(AlrHr3),ZL,low(AlrHr3)
	jmp	ind_alarm


ind_mode12:			;   12

	ldi2	ZH,high(set_alm_cl*2),ZL,low(set_alm_cl*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM1+14),ZL,low(LcdRAM1+14)
	ldi	Temp1,'1'
	st	Z,Temp1
	ldi2	ZH,high(AlrHr1),ZL,low(AlrHr1)
	jmp	ind_alarm

ind_mode13:			;   13

	ldi2	ZH,high(set_alm_cl*2),ZL,low(set_alm_cl*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM1+14),ZL,low(LcdRAM1+14)
	ldi	Temp1,'2'
	st	Z,Temp1
	ldi2	ZH,high(AlrHr2),ZL,low(AlrHr2)
	jmp	ind_alarm

ind_mode14:			;   14

	ldi2	ZH,high(set_alm_cl*2),ZL,low(set_alm_cl*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM1+14),ZL,low(LcdRAM1+14)
	ldi	Temp1,'3'
	st	Z,Temp1
	ldi2	ZH,high(AlrHr3),ZL,low(AlrHr3)
	jmp	ind_alarm

ind_mode15:			;   15

	ldi2	ZH,high(menu*2),ZL,low(menu*2)
	call	write_vr_1line
	ldi2	ZH,high(set_timers*2),ZL,low(set_timers*2)
	jmp	write_vr_2line

ind_mode16:			;   16

	ldi2	ZH,high(oneset*2),ZL,low(oneset*2)
	jmp	write_videoram

ind_mode17:			;   17

	ldi2	ZH,high(time_prog*2),ZL,low(time_prog*2)
	jmp	write_videoram

ind_mode18:			;   18

	ldi2	ZH,high(termo_contr*2),ZL,low(termo_contr*2)
	jmp	write_videoram

ind_mode19:			;   19

	ldi2	ZH,high(timer_load*2),ZL,low(timer_load*2)
	call	write_vr_1line

	lds	Temp1,TimerLoadHour
	sts	fASCIIL,Temp1
	clr	Temp1
	sts	fASCIIH,Temp1
	call	bin2ASCII16
	ldi2	ZH,high(LcdRAM1+7),ZL,low(LcdRAM1+7)
	ldi2	YH,high(tASCII2),YL,low(tASCII2)
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	adiw	ZL,1
	lds	Temp1,TimerLoadMin
	sts	fASCIIL,Temp1
	clr	Temp1
	sts	fASCIIH,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1

	SKBC	Flags,LOAD_ON
	rjmp	indm19_21

indm19_31:
	ldi2	ZH,high(timer_load_pow*2),ZL,low(timer_load_pow*2)
	call	write_vr_2line
	ldi2	ZH,high(Adjust2H),ZL,low(Adjust2H)
	call	NN_power
	ldi2	ZH,high(LcdRAM2+5),ZL,low(LcdRAM2+5)
	ldi2	YH,high(tASCII2),YL,low(tASCII2)
	ld	Temp1,Y+
	cpi	Temp1,'0'
	brne	indm19_1		;   <>0,  
	ldi	Temp1,' '
indm19_1:	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	adiw	ZL,2

	lds	Temp2,TimerLoadFlag
	sbrc	Temp2,TIM_ONE_EN	;  , 
	rjmp	indm19_4
indm19_dis:
	ldi	Temp1,$af
	st	Z+,Temp1		;   ""
	ldi	Temp1,'A'
	st	Z+,Temp1		;   "A"
	ldi	Temp1,$a8
	st	Z+,Temp1		;   ""
	ldi	Temp1,'P'
	st	Z+,Temp1		;   ""
	ret
indm19_21:	sbrc	Second,2
	rjmp	indm19_31
	ldi2	ZH,high(mes_load_on*2),ZL,low(mes_load_on*2)
	jmp	write_vr_2line


indm19_4:	sbrs	Temp2,TIM_LOAD_CYCLE	;  ,  
	rjmp	indm19_2

indm19_toggle:
	ldi	Temp1,$a8
	st	Z+,Temp1		;   ""
	ldi	Temp1,'E'
	st	Z+,Temp1		;   ""
	ldi	Temp1,'P'
	st	Z+,Temp1		;   ""
	ldi	Temp1,'E'
	st	Z+,Temp1		;   "E"
	ldi	Temp1,'K'
	st	Z+,Temp1		;   "K"
	ldi	Temp1,$a7
	st	Z+,Temp1		;   ""
	ret

indm19_2:	sbrc	Temp2,TIM_LOAD_ONOFF	; ,  
	rjmp	indm19_on
indm19_off:
	ldi	Temp1,'O'
	st	Z+,Temp1		;   ""
	ldi	Temp1,'T'
	st	Z+,Temp1		;   ""
	ldi	Temp1,'K'
	st	Z+,Temp1		;   ""
	ldi	Temp1,$a7
	st	Z+,Temp1		;   ""
	ret

indm19_on:
	ldi	Temp1,'B'
	st	Z+,Temp1		;   "B"
	ldi	Temp1,'K'
	st	Z+,Temp1		;   ""
	ldi	Temp1,$a7
	st	Z+,Temp1		;   ""
	ret

;------------------------

ind_mode20:			;   20

	ldi2	ZH,high(timer_point*2),ZL,low(timer_point*2)
	call	write_vr_1line
	ldi2	ZH,high(timer_load_pow*2),ZL,low(timer_load_pow*2)
	call	write_vr_2line

	mov	Temp1,Point
	inc	Temp1
	sts	fASCIIL,Temp1
	clr	Temp1
	sts	fASCIIH,Temp1
	call	bin2ASCII16
	ldi2	ZH,high(LcdRAM1+6),ZL,low(LcdRAM1+6)
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	cpi	Temp1,'0'
	brne	indm20_1
	ldi	Temp1,' '
indm20_1:	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	adiw	ZL,1

	lds	Temp1,SetTimHour
	sts	fASCIIL,Temp1
	clr	Temp1
	sts	fASCIIH,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	adiw	ZL,1

	lds	Temp1,SetTimMin
	sts	fASCIIL,Temp1
	clr	Temp1
	sts	fASCIIH,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1

	movw	YL,ZL
	ldi2	ZH,high(day_n*2),ZL,low(day_n*2)
	lds	Temp1,SetTimDay	;   
	andi	Temp1,$1f
	clr	Temp2
	lsl	Temp1
	rol	Temp2
	add	ZL,Temp1
	adc	ZH,Temp2
	lpm	Temp1,Z+		;  
	st	Y+,Temp1
	lpm	Temp1,Z		;  
	st	Y+,Temp1
	movw	ZL,YL

	ldi2	ZH,high(SetTimPowH),ZL,low(SetTimPowH)
	call	NN_power
	ldi2	ZH,high(LcdRAM2+5),ZL,low(LcdRAM2+5)
	ldi2	YH,high(tASCII2),YL,low(tASCII2)
	ld	Temp1,Y+
	cpi	Temp1,'0'
	brne	indm20_2		;   <>0,  
	ldi	Temp1,' '
indm20_2:	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1

	lds	Temp2,TimerLoadFlag
	sbrc	Temp2,TPROG_EN	; , 
	rjmp	indm20_3
	sbrc	Second,1
	ret	

indm20_3:	adiw	ZL,2
	lds	Temp2,SetTimDay
	sbrs	Temp2,7		;  , 
	rjmp	indm19_dis
	sbrc	Temp2,6		;  , 
	rjmp	indm19_toggle
	sbrc	Temp2,5		; ,  
	rjmp	indm19_on
	rjmp	indm19_off

ind_mode21:			;   21

	ldi2	ZH,high(set_termostat*2),ZL,low(set_termostat*2)
	call	write_vr_1line

	SKBC	Flags,LOAD_ON
	rjmp	indm21_21

indm21_31:	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM2),ZL,low(LcdRAM2)
	ldi	Temp1,'T'
	st	Z+,Temp1		;   "T"
	ldi	Temp1,'='
	st	Z+,Temp1		;   "="
	lds	Temp1,SetTermostatL
	sts	fASCIIL,Temp1
	lds	Temp1,SetTermostatH
	sts	fASCIIH,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII2),YL,low(tASCII2)
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ldi	Temp1,','
	st	Z+,Temp1		;   ","
	ld	Temp1,Y+
	st	Z+,Temp1

	ldi	Temp1,$ef
	st	Z+,Temp1		;   ""
	ldi	Temp1,'C'
	st	Z+,Temp1		;   ""
	adiw	ZL,1

	lds	Temp2,TimerLoadFlag
	sbrs	Temp2,TSTAT_EN	;  , 
	rjmp	indm19_dis

	sbrc	Temp2,TSTAT_ONOFF	; ,  
	rjmp	indm21_1
	ldi	Temp1,'O'
	st	Z+,Temp1		;   "O"
	ldi	Temp1,'X'
	st	Z+,Temp1		;   "X"
	ldi	Temp1,$a7
	st	Z+,Temp1		;   ""
	ldi	Temp1,'A'
	st	Z+,Temp1		;   "A"
	ldi	Temp1,$e0
	st	Z+,Temp1		;   ""
	ldi	Temp1,'.'
	st	Z+,Temp1		;   "."
	ret
indm21_21:	sbrc	Second,2
	rjmp	indm21_31
	ldi2	ZH,high(mes_load_on*2),ZL,low(mes_load_on*2)
	jmp	write_vr_2line

indm21_1:
	ldi	Temp1,'H'
	st	Z+,Temp1		;   "H"
	ldi	Temp1,'A'
	st	Z+,Temp1		;   "A"
	ldi	Temp1,$a1
	st	Z+,Temp1		;   ""
	ldi	Temp1,'P'
	st	Z+,Temp1		;   "P"
	ldi	Temp1,'E'
	st	Z+,Temp1		;   "E"
	ldi	Temp1,'B'
	st	Z+,Temp1		;   "B"
	ldi	Temp1,'.'
	st	Z+,Temp1		;   "."
	ret

ind_mode22:			;   22

	ldi2	ZH,high(menu*2),ZL,low(menu*2)
	call	write_vr_1line
	ldi2	ZH,high(set_params*2),ZL,low(set_params*2)
	jmp	write_vr_2line

ind_mode23:			;   23

	ldi2	ZH,high(setting*2),ZL,low(setting*2)
	call	write_vr_1line
	ldi2	ZH,high(clock_date*2),ZL,low(clock_date*2)
	jmp	write_vr_2line

ind_mode24:			;   24

	ldi2	ZH,high(calibr*2),ZL,low(calibr*2)
	call	write_vr_1line
	ldi2	ZH,high(clocks*2),ZL,low(clocks*2)
	jmp	write_vr_2line

ind_mode25:			;   25

	ldi2	ZH,high(calibr*2),ZL,low(calibr*2)
	call	write_vr_1line
	ldi2	ZH,high(termodats*2),ZL,low(termodats*2)
	jmp	write_vr_2line

ind_mode26:			;   26

	ldi2	ZH,high(adjust*2),ZL,low(adjust*2)
	call	write_vr_1line
	ldi2	ZH,high(contr_backl*2),ZL,low(contr_backl*2)
	jmp	write_vr_2line

ind_mode27:			;   27

	ldi2	ZH,high(setting*2),ZL,low(setting*2)
	call	write_vr_1line
	ldi2	ZH,high(spec_params*2),ZL,low(spec_params*2)
	jmp	write_vr_2line

ind_mode28:			;   28

	ldi2	ZH,high(set_clock*2),ZL,low(set_clock*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM2+3),ZL,low(LcdRAM2+3)
	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ldi2	XH,high(Hour),XL,low(Hour)

	ld	Temp1,X		;      ASCII
	st	Y+,Temp1
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1		;   
	ld	Temp1,Y+
	st	Z+,Temp1		;   
	ldi	Temp1,':'
	st	Z+,Temp1		; 

	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ld	Temp1,-X
	st	Y+,Temp1		;      ASCII
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1		;   
	ld	Temp1,Y
	st	Z+,Temp1		;   
	ldi	Temp1,':'
	st	Z+,Temp1		; 

	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	mov	Temp1,Second
	lsr	Temp1
	lsr	Temp1
	st	Y+,Temp1		;      ASCII
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1		;   
	ld	Temp1,Y
	st	Z+,Temp1		;   
	ldi	Temp1,' '
	st	Z+,Temp1		; 

	ldi2	XH,high(NameDays),XL,low(NameDays)
	movw	YL,ZL
	ldi2	ZH,high(day_n*2),ZL,low(day_n*2)
	ld	Temp1,X+		;   
	clr	Temp2
	lsl	Temp1
	rol	Temp2
	add	ZL,Temp1
	adc	ZH,Temp2
	lpm	Temp1,Z+		;  
	st	Y+,Temp1
	lpm	Temp1,Z		;  
	st	Y,Temp1

	ret

ind_mode29:			;   29

	ldi2	ZH,high(set_date*2),ZL,low(set_date*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM2+1),ZL,low(LcdRAM2+1)
	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ldi2	XH,high(Day),XL,low(Day)

	ld	Temp1,X+		;      ASCII
	st	Y+,Temp1
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1		;   
	ld	Temp1,Y+
	st	Z+,Temp1		;   
	ldi	Temp1,'-'
	st	Z+,Temp1		; 

	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ld	Temp1,X+
	st	Y+,Temp1		;     ASCII
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1		;   
	ld	Temp1,Y
	st	Z+,Temp1		;   
	ldi	Temp1,'-'
	st	Z+,Temp1		; 

	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ld	Temp1,X
	st	Y+,Temp1		;     ASCII
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII2),YL,low(tASCII2)
	ldi	Temp1,'2'
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1		;  
	ld	Temp1,Y+
	st	Z+,Temp1		;  
	ld	Temp1,Y
	st	Z+,Temp1		;  
	SKBS	FlagsLCD,SUM_ON		;     ,  
	ret
	ldi	Temp1,$bb
	st	Z+,Temp1
	ldi	Temp1,'e'
	st	Z+,Temp1
	ldi	Temp1,$bf
	st	Z+,Temp1
	ldi	Temp1,$bd
	st	Z+,Temp1
	ret

ind_mode30:			;   30

	ldi2	ZH,high(cal_clock*2),ZL,low(cal_clock*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	jmp	write_vr_2line

ind_mode31:			;   31

	ldi2	ZH,high(sel_termodat*2),ZL,low(sel_termodat*2)
	call	write_vr_1line
	clr	Temp1
	sts	CntHoldInd,Temp1	; ,     
	ldi2	ZH,high(dat_in*2),ZL,low(dat_in*2)
	jmp	write_vr_2line

ind_mode32:			;   32

	ldi2	ZH,high(sel_termodat*2),ZL,low(sel_termodat*2)
	call	write_vr_1line
	clr	Temp1
	sts	CntHoldInd,Temp1	; ,     
	ldi2	ZH,high(dat_out*2),ZL,low(dat_out*2)
	jmp	write_vr_2line

ind_mode33:			;   33

	ldi2	ZH,high(sel_termodat*2),ZL,low(sel_termodat*2)
	call	write_vr_1line
	clr	Temp1
	sts	CntHoldInd,Temp1	; ,     
	ldi2	ZH,high(dat_dop*2),ZL,low(dat_dop*2)
	jmp	write_vr_2line

ind_mode34:			;   34

	ldi2	ZH,high(term_value*2),ZL,low(term_value*2)
	call	write_vr_1line
	ldi2	ZH,high(cal_terms*2),ZL,low(cal_terms*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM1+1),ZL,low(LcdRAM1+1)
	ldi	Temp1,'1'
	st	Z+,Temp1
	lds	Temp1,DataTerm1L
	sts	fASCIIL,Temp1
	lds	Temp1,DataTerm1H
	sts	fASCIIH,Temp1
	call	bin2ASCII16
	ldi2	ZH,high(LcdRAM1+12),ZL,low(LcdRAM1+12)
	ldi2	YH,high(tASCII3),YL,low(tASCII3)
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y
	st	Z,Temp1

	ldi2	ZH,high(DataTerm1L),ZL,low(DataTerm1L)
;	ldi2	XH,high(_TermK1L),XL,low(_TermK1L)

	tst	Rate
	breq	indm34_1
	ret;jmp	cal_termod

indm34_1:	ret;jmp	cal_termod0

ind_mode35:			;   35

	ldi2	ZH,high(term_value*2),ZL,low(term_value*2)
	call	write_vr_1line
	ldi2	ZH,high(cal_terms*2),ZL,low(cal_terms*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM1+1),ZL,low(LcdRAM1+1)
	ldi	Temp1,'2'
	st	Z+,Temp1
	lds	Temp1,DataTerm2L
	sts	fASCIIL,Temp1
	lds	Temp1,DataTerm2H
	sts	fASCIIH,Temp1
	call	bin2ASCII16
	ldi2	ZH,high(LcdRAM1+12),ZL,low(LcdRAM1+12)
	ldi2	YH,high(tASCII3),YL,low(tASCII3)
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y
	st	Z,Temp1

	ldi2	ZH,high(DataTerm2L),ZL,low(DataTerm2L)
;	ldi2	XH,high(_TermK2L),XL,low(_TermK2L)

	tst	Rate
	breq	indm35_1
ret;	jmp	cal_termod

indm35_1:	ret;jmp	cal_termod0

ind_mode36:			;   36

	ldi2	ZH,high(term_value*2),ZL,low(term_value*2)
	call	write_vr_1line
	ldi2	ZH,high(cal_terms*2),ZL,low(cal_terms*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM1+1),ZL,low(LcdRAM1+1)
	ldi	Temp1,'3'
	st	Z+,Temp1
	lds	Temp1,DataTerm3L
	sts	fASCIIL,Temp1
	lds	Temp1,DataTerm3H
	sts	fASCIIH,Temp1
	call	bin2ASCII16
	ldi2	ZH,high(LcdRAM1+12),ZL,low(LcdRAM1+12)
	ldi2	YH,high(tASCII3),YL,low(tASCII3)
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y+
	st	Z+,Temp1
	ld	Temp1,Y
	st	Z,Temp1

	ldi2	ZH,high(DataTerm3L),ZL,low(DataTerm3L)
;	ldi2	XH,high(_TermK3L),XL,low(_TermK3L)

	tst	Rate
	breq	indm36_1
ret;	jmp	cal_termod

indm36_1:	ret;jmp	cal_termod0


ind_mode37:			;   37

	ldi2	ZH,high(contr_backl*2),ZL,low(contr_backl*2)
	call	write_vr_1line
	ldi2	ZH,high(contrast*2),ZL,low(contrast*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM2+11),ZL,low(LcdRAM2+11)
	lds	Temp1,FlagsRAM
	sbrs	Temp1,BACKLIGHT_AUTO	;   ,  
	rjmp	indm37_1
	ldi	Temp1,'A'
	st	Z+,Temp1
	ldi	Temp1,'B'
	st	Z+,Temp1
	ldi	Temp1,'T'		; "ABTO"
	st	Z+,Temp1
	ldi	Temp1,'O'
	st	Z,Temp1
	ret
indm37_1:	sbrs	Temp1,BACKLIGHT_ON	;  ,  
	rjmp	indm19_off
	rjmp	indm19_on
	

ind_mode38:			;   38

	ldi2	ZH,high(spec_par*2),ZL,low(spec_par*2)
	call	write_vr_1line
	ldi2	ZH,high(porog_3v*2),ZL,low(porog_3v*2)
	jmp	write_vr_2line

ind_mode39:			;   39

	ldi2	ZH,high(spec_par*2),ZL,low(spec_par*2)
	call	write_vr_1line
	ldi2	ZH,high(porog_foto*2),ZL,low(porog_foto*2)
	jmp	write_vr_2line

ind_mode40:			;   40

	ldi2	ZH,high(spec_par*2),ZL,low(spec_par*2)
	call	write_vr_1line
	ldi2	ZH,high(sounds*2),ZL,low(sounds*2)
	jmp	write_vr_2line

ind_mode41:			;   41

	ldi2	ZH,high(spec_par*2),ZL,low(spec_par*2)
	call	write_vr_1line
	ldi2	ZH,high(light_but*2),ZL,low(light_but*2)
	jmp	write_vr_2line

ind_mode42:			;   42

	ldi2	ZH,high(porog_3v*2),ZL,low(porog_3v*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	jmp	write_vr_2line

ind_mode43:			;   43

	ldi2	ZH,high(porog_foto*2),ZL,low(porog_foto*2)
	call	write_vr_1line
	ldi2	ZH,high(clear_line*2),ZL,low(clear_line*2)
	jmp	write_vr_2line

ind_mode44:			;   44

	ldi2	ZH,high(sounds*2),ZL,low(sounds*2)
	call	write_vr_1line
	ldi2	ZH,high(every_hour*2),ZL,low(every_hour*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM2+12),ZL,low(LcdRAM2+12)
	SKBS	FlagsLCD,SOUND_HOUR	;    ,  
	rjmp	indm19_off
	rjmp	indm19_on

ind_mode45:			;   45

	ldi2	ZH,high(sounds*2),ZL,low(sounds*2)
	call	write_vr_1line
	ldi2	ZH,high(buttons*2),ZL,low(buttons*2)
	call	write_vr_2line

	ldi2	ZH,high(LcdRAM2+10),ZL,low(LcdRAM2+10)
	SKBS	FlagsLCD,SOUND_BUT	;    ,  
	rjmp	indm19_off
	rjmp	indm19_on

ind_mode46:			;   46

	ldi2	ZH,high(light_but*2),ZL,low(light_but*2)
	call	write_vr_1line

	ldi2	ZH,high(LcdRAM2+10),ZL,low(LcdRAM2+10)
	lds	Temp1,FlagsRAM
	sbrs	Temp1,BUTLIGHT_ON	;   ,  
	rjmp	indm46_1
	sbrs	Temp1,BUTLIGHT_BL	;    ,  
	rjmp	indm46_2
	ldi2	ZH,high(blinking*2),ZL,low(blinking*2)
	jmp	write_vr_2line

indm46_1:	ldi2	ZH,high(off*2),ZL,low(off*2)
	jmp	write_vr_2line

indm46_2:	ldi2	ZH,high(on*2),ZL,low(on*2)
	jmp	write_vr_2line



;********************************* /       **************************

mode0_but1:
	call	set_mode_5
	jmp	add_power_lamp

mode0_but2:
	call	set_mode_5
	jmp	sub_power_lamp

mode1_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	lds	Temp1,TimerLampTemp
	SKBC	FlagsButton,MULTI	;   , 
	subi	Temp1,(-10)
	SKBS	FlagsButton,MULTI	;   , 
	inc	Temp1		; 
	cpi	Temp1,241
	brlo	md1bt2_1		; TimerLampTemp<241,  
	clr	Temp1
	rjmp	md1bt2_1

mode1_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	lds	Temp1,TimerLampTemp
	SKBC	FlagsButton,MULTI	;   , 
	subi	Temp1,10
	SKBS	FlagsButton,MULTI	;   , 
	dec	Temp1		; 
	tst	Temp1
	brpl	md1bt2_1		; TimerLampTemp>=0,  
	ldi	Temp1,240
md1bt2_1:	sts	TimerLampTemp,Temp1
	sts	TimerLamp,Temp1
	SETB	FlagsRAM,TIMER_LAMP	;  
	ret

mode1_but5:
	lds	Temp1,FlagsRAM
	sbrs	Temp1,TIMER_LAMP	;,    
	rjmp	on_tmrlmp1
	cbr	Temp1,(1<<TIMER_LAMP)	;  
	sts	FlagsRAM,Temp1
	lds	Temp1,TimerLamp
	sts	TimerLampTemp,Temp1
	ret
on_tmrlmp1:	
	lds	Temp1,TimerLamp
	sts	TimerLampTemp,Temp1
	sbr	Temp1,(1<<TIMER_LAMP)	;  
	sts	FlagsRAM,Temp1
	ret

mode2_but1:
	SKBC	Flags,LOAD_ON
	jmp	add_power_load
	lds	Temp1,TimerLoadFlag
	cbr	Temp1,(1<<TIM_ONE_EN)+(1<<TSTAT_EN)+(1<<TPROG_EN)
	sts	TimerLoadFlag,Temp1
	ret

mode2_but2:
	SKBC	Flags,LOAD_ON
	jmp	sub_power_load
	lds	Temp1,TimerLoadFlag
	cbr	Temp1,(1<<TIM_ONE_EN)+(1<<TSTAT_EN)+(1<<TPROG_EN)
	sts	TimerLoadFlag,Temp1
	ret

mode9_but3:
	ldi	Temp1,$c0
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	jmp	add_mode_3

mode10_but3:
	ldi	Temp1,$c0
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	jmp	add_mode_3

mode11_but3:
	ldi	Temp1,$c0
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	jmp	add_mode_3

mode12_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate12_but1),ZL,low(rate12_but1)
	rjmp	rjmp_rate

mode12_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate12_but2),ZL,low(rate12_but2)
	rjmp	rjmp_rate

mode12_but3:
	ldi2	ZH,high(rate12_but3),ZL,low(rate12_but3)
	rjmp	rjmp_rate

mode13_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate13_but1),ZL,low(rate13_but1)
	rjmp	rjmp_rate

mode13_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate13_but2),ZL,low(rate13_but2)
	rjmp	rjmp_rate

mode13_but3:
	ldi2	ZH,high(rate13_but3),ZL,low(rate13_but3)
	rjmp	rjmp_rate

mode14_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate14_but1),ZL,low(rate14_but1)
	rjmp	rjmp_rate

mode14_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate14_but2),ZL,low(rate14_but2)
	rjmp	rjmp_rate

mode14_but3:
	ldi2	ZH,high(rate14_but3),ZL,low(rate14_but3)
	rjmp	rjmp_rate

mode12_but4:
mode13_but4:
mode14_but4:
	clr	Rate
	jmp	sub_mode_3

mode12_but5:
mode13_but5:
	SETB	FlagsLCD,LCD_COM
	ldi	Temp1,$c0		; 
	sts	LcdComWrite,Temp1
	clr	Rate
	jmp	inc_mode

mode14_but5:
	SETB	FlagsLCD,LCD_COM
	ldi	Temp1,$c0		; 
	sts	LcdComWrite,Temp1
	clr	Rate
	jmp	sub_mode_2


mode16_but3:
	ldi	Temp1,$88
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	jmp	add_mode_3


mode17_but3:
	ldi2	XL,low(_TPoint0),XH,high(_TPoint0)
	call	copy_point
	ldi	Temp1,$86
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	clr	Point
	jmp	add_mode_3

mode18_but3:
	ldi	Temp1,$c2
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	jmp	add_mode_3


mode19_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate19_but1),ZL,low(rate19_but1)
	rjmp	rjmp_rate

mode19_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate19_but2),ZL,low(rate19_but2)
	rjmp	rjmp_rate

mode19_but3:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate19_but3),ZL,low(rate19_but3)
	rjmp	rjmp_rate

mode19_but5:
	call	onoff_load
	SETB	FlagsLCD,LCD_COM
	ldi	Temp1,_TimIndRet
	sts	CntHoldInd,Temp1
	ret

mode20_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate20_but1),ZL,low(rate20_but1)
	rjmp	rjmp_rate

mode20_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate20_but2),ZL,low(rate20_but2)
	rjmp	rjmp_rate

mode20_but3:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate20_but3),ZL,low(rate20_but3)
	rjmp	rjmp_rate

mode20_but5:
	SETB	FlagsLCD,LCD_COM
	lds	Temp1,TimerLoadFlag
	sbrc	Temp1,TPROG_EN	;  , 
	rjmp	md20b5_1
	sbr	Temp1,(1<<TPROG_EN)
	cbr	Temp1,(1<<TIM_ONE_EN)+(1<<TSTAT_EN)
	rjmp	md20b5_2
md20b5_1:	cbr	Temp1,(1<<TPROG_EN)
md20b5_2:	sts	TimerLoadFlag,Temp1
	ret

mode21_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate21_but1),ZL,low(rate21_but1)
	rjmp	rjmp_rate

mode21_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate21_but2),ZL,low(rate21_but2)
	rjmp	rjmp_rate

mode21_but3:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate21_but3),ZL,low(rate21_but3)
	rjmp	rjmp_rate

mode21_but5:
	call	onoff_load
	SETB	FlagsLCD,LCD_COM
	ldi	Temp1,_TimIndRet
	sts	CntHoldInd,Temp1
	ret

mode23_but3:
	ldi	Temp1,$c3
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	jmp	add_mode_5

rjmp_rate:	SETB	FlagsLCD,LCD_COM
	clr	Temp1
	add	ZL,Rate
	adc	ZH,Temp1
	ijmp
;---------

;**********************************************************************************************
work_mode:		;    

	rjmp	mode0_but1
	rjmp	mode0_but2
	rjmp	add_mode_8		;mode0_but3
	rjmp	inc_mode		;mode0_but4
	rjmp	onoff_lamp		;mode0_but5

	rjmp	mode1_but1
	rjmp	mode1_but2
	rjmp	set_mode_0		;mode1_but3
	rjmp	inc_mode		;mode1_but4
	rjmp	mode1_but5

	rjmp	mode2_but1
	rjmp	mode2_but2
	rjmp	set_mode_0		;mode2_but3
	rjmp	inc_mode		;mode2_but4
	rjmp	onoff_load		;mode2_but5

	ret			;mode3_but1
	ret			;mode3_but2
	ret			;mode3_but3
	rjmp	set_mode_0		;mode3_but4
	rjmp	onoff_lamp		;mode3_but5

	rjmp	set_mode_0		;mode4_but1
	rjmp	set_mode_0		;mode4_but2
	rjmp	set_mode_0		;mode4_but3
	rjmp	set_mode_0		;mode4_but4
	rjmp	onoff_lamp		;mode4_but5

	rjmp	add_power_lamp	;mode5_but1
	rjmp	sub_power_lamp	;mode5_but2
	rjmp	ret_mode_0		;mode5_but3
	rjmp	set_mode_0		;mode5_but4
	rjmp	onoff_lamp		;mode5_but5

	ret
	ret
	ret
	rjmp	set_mode_0		;mode6_but4
	rjmp	onoff_lamp		;mode6_but5

	ret			;mode7_but1
	ret			;mode7_but2
	ret			;mode7_but3
	rjmp	set_mode_0		;mode7_but4
	rjmp	onoff_lamp		;mode7_but5

	rjmp	add_mode_7		;mode8_but1
	rjmp	set_mode_22		;mode8_but2
	rjmp	inc_mode		;mode8_but3
	rjmp	set_mode_0		;mode8_but4
	rjmp	set_mode_0		;mode8_but5

	rjmp	inc_mode		;mode9_but1
	rjmp	add_mode_2		;mode9_but2
	rjmp	mode9_but3
	rjmp	dec_mode		;mode9_but4
	rjmp	set_mode_0		;mode9_but5

	rjmp	inc_mode		;mode10_but1
	rjmp	dec_mode		;mode10_but2
	rjmp	mode10_but3
	rjmp	sub_mode_2		;mode10_but4
	rjmp	set_mode_0		;mode10_but5

	rjmp	sub_mode_2		;mode11_but1
	rjmp	dec_mode		;mode11_but2
	rjmp	mode11_but3
	rjmp	sub_mode_3		;mode11_but4
	rjmp	set_mode_0		;mode11_but5

	rjmp	mode12_but1
	rjmp	mode12_but2
	rjmp	mode12_but3
	rjmp	mode12_but4
	rjmp	mode12_but5

	rjmp	mode13_but1
	rjmp	mode13_but2
	rjmp	mode13_but3
	rjmp	mode13_but4
	rjmp	mode13_but5

	rjmp	mode14_but1
	rjmp	mode14_but2
	rjmp	mode14_but3
	rjmp	mode14_but4
	rjmp	mode14_but5

	rjmp	add_mode_7		;mode15_but1
	rjmp	sub_mode_7		;mode15_but2
	rjmp	inc_mode		;mode15_but3
	rjmp	set_mode_0		;mode15_but4
	rjmp	set_mode_0		;mode15_but5

	rjmp	inc_mode		;mode16_but1
	rjmp	add_mode_2		;mode16_but2
	rjmp	mode16_but3
	rjmp	dec_mode		;mode16_but4
	rjmp	set_mode_0		;mode16_but5

	rjmp	inc_mode		;mode17_but1
	rjmp	dec_mode		;mode17_but2
	rjmp	mode17_but3
	rjmp	sub_mode_2		;mode17_but4
	rjmp	set_mode_0		;mode17_but5

	rjmp	sub_mode_2		;mode18_but1
	rjmp	dec_mode		;mode18_but2
	rjmp	mode18_but3
	rjmp	sub_mode_3		;mode18_but4
	rjmp	set_mode_0		;mode18_but5

	rjmp	mode19_but1
	rjmp	mode19_but2
	rjmp	mode19_but3
	rjmp	sub_mode_3		;mode19_but4
	rjmp	mode19_but5

	rjmp	mode20_but1
	rjmp	mode20_but2
	rjmp	mode20_but3
	rjmp	sub_mode_3		;mode20_but4
	rjmp	mode20_but5

	rjmp	mode21_but1
	rjmp	mode21_but2
	rjmp	mode21_but3
	rjmp	sub_mode_3		;mode21_but4
	rjmp	mode21_but5

	rjmp	set_mode_8		;mode22_but1
	rjmp	sub_mode_7		;mode22_but2
	rjmp	inc_mode		;mode22_but3
	rjmp	set_mode_0		;mode22_but4
	rjmp	set_mode_0		;mode22_but5

	rjmp	inc_mode		;mode23_but1
	rjmp	add_mode_4		;mode23_but2
	rjmp	mode23_but3
	rjmp	dec_mode		;mode23_but4
	rjmp	set_mode_0		;mode23_but5

	rjmp	add_mode_2		;mode24_but1
	rjmp	dec_mode		;mode24_but2
	rjmp	add_mode_6		;mode24_but3
	rjmp	sub_mode_2		;mode24_but4
	rjmp	set_mode_0		;mode24_but5

	rjmp	inc_mode		;mode25_but1
	rjmp	sub_mode_2		;mode25_but2
	rjmp	add_mode_6		;mode25_but3
	rjmp	sub_mode_3		;mode25_but4
	rjmp	set_mode_0		;mode25_but5

	rjmp	inc_mode		;mode26_but1
	rjmp	dec_mode		;mode26_but2
	rjmp	mode26_but3
	rjmp	sub_mode_4		;mode26_but4
	rjmp	set_mode_0		;mode26_but5

	rjmp	sub_mode_4		;mode27_but1
	rjmp	dec_mode		;mode27_but2
	rjmp	add_mode_11		;mode27_but3
	rjmp	sub_mode_5		;mode27_but4
	rjmp	set_mode_0		;mode27_but5

	rjmp	mode28_but1
	rjmp	mode28_but2
	rjmp	mode28_but3
	rjmp	mode28_but4
	rjmp	mode28_but5

	rjmp	mode29_but1
	rjmp	mode29_but2
	rjmp	mode29_but3
	rjmp	mode29_but4
	rjmp	mode29_but5

ret;	rjmp	mode30_but1
ret;	rjmp	mode30_but2
ret;	rjmp	mode30_but3
	rjmp	sub_mode_6		;mode30_but4
ret;	rjmp	mode30_but5

	rjmp	inc_mode		;mode31_but1
	rjmp	add_mode_2		;mode31_but2
	rjmp	mode31_but3
	rjmp	sub_mode_6		;mode31_but4
	rjmp	set_mode_0		;mode31_but5

	rjmp	inc_mode		;mode32_but1
	rjmp	dec_mode		;mode32_but2
	rjmp	mode32_but3
	rjmp	sub_mode_7		;mode32_but4
	rjmp	set_mode_0		;mode32_but5

	rjmp	sub_mode_2		;mode33_but1
	rjmp	dec_mode		;mode33_but2
	rjmp	mode33_but3
	rjmp	sub_mode_8		;mode33_but4
	rjmp	inc_mode		;mode33_but5

	rjmp	mode34_but1
	rjmp	mode34_but2
	rjmp	mode34_but3
	rjmp	mode34_but4
	ret			;mode34_but5

	rjmp	mode35_but1
	rjmp	mode35_but2
	rjmp	mode35_but3
	rjmp	mode35_but4
	ret			;mode35_but5

	rjmp	mode36_but1
	rjmp	mode36_but2
	rjmp	mode36_but3
	rjmp	mode36_but4
	ret			;mode36_but5

	rjmp	mode37_but1
	rjmp	mode37_but2
	rjmp	mode37_but3
	rjmp	sub_mode_11		;mode37_but4
	rjmp	inc_mode		;mode37_but5

	rjmp	inc_mode		;mode38_but1
	rjmp	add_mode_3		;mode38_but2
	rjmp	add_mode_4		;mode38_but3
	rjmp	sub_mode_11		;mode38_but4
	rjmp	set_mode_0		;mode38_but5

	rjmp	inc_mode		;mode39_but1
	rjmp	dec_mode		;mode39_but2
	rjmp	add_mode_4		;mode39_but3
	rjmp	sub_mode_12		;mode39_but4
	rjmp	set_mode_0		;mode39_but5

	rjmp	inc_mode		;mode40_but1
	rjmp	dec_mode		;mode40_but2
	rjmp	add_mode_4		;mode40_but3
	rjmp	sub_mode_13		;mode40_but4
	rjmp	set_mode_0		;mode40_but5

	rjmp	sub_mode_3		;mode41_but1
	rjmp	dec_mode		;mode41_but2
	rjmp	add_mode_5		;mode41_but3
	rjmp	sub_mode_14		;mode41_but4
	rjmp	set_mode_0		;mode41_but5


ret;	rjmp	mode42_but1
ret;	rjmp	mode42_but2
ret;	rjmp	mode42_but3
	rjmp	sub_mode_3		;mode42_but4
	rjmp	set_mode_0		;mode42_but5

ret;	rjmp	dec_mode		;mode43_but1
ret;	rjmp	dec_mode		;mode43_but2
ret;	rjmp	add_mode_2		;mode43_but3
	rjmp	sub_mode_3		;mode43_but4
	rjmp	set_mode_0		;mode43_but5

	rjmp	mode44_but1
	rjmp	mode44_but2
	rjmp	inc_mode		;mode44_but3
	rjmp	sub_mode_4		;mode44_but4
	rjmp	set_mode_0		;mode44_but5

	rjmp	mode45_but1
	rjmp	mode45_but2
	rjmp	dec_mode		;mode45_but3
	rjmp	sub_mode_5		;mode45_but4
	rjmp	set_mode_0		;mode45_but5

	rjmp	mode46_but1
	rjmp	mode46_but2
	rjmp	sub_mode_5		;mode46_but3
	rjmp	sub_mode_5		;mode46_but4
	rjmp	set_mode_0		;mode46_but5

;*************************************************************************************************


rate12_but1:
	rjmp	m12_b1_r0
	rjmp	m12_b1_r1
	rjmp	m12_b1_r2
	rjmp	m12_b1_r3
	rjmp	m12_b1_r4
	rjmp	m12_b1_r5
	rjmp	m12_b1_r6

rate12_but2:
	rjmp	m12_b2_r0
	rjmp	m12_b2_r1
	rjmp	m12_b2_r2
	rjmp	m12_b2_r3
	rjmp	m12_b2_r4
	rjmp	m12_b2_r5
	rjmp	m12_b2_r6

rate12_but3:
	rjmp	m12_b3_r0
	rjmp	m12_b3_r1
	rjmp	m12_b3_r2
	rjmp	m12_b3_r3
	rjmp	m12_b3_r4
	rjmp	m12_b3_r5
	rjmp	m12_b3_r6

rate13_but1:
	rjmp	m13_b1_r0
	rjmp	m13_b1_r1
	rjmp	m13_b1_r2
	rjmp	m13_b1_r3
	rjmp	m13_b1_r4
	rjmp	m13_b1_r5
	rjmp	m13_b1_r6

rate13_but2:
	rjmp	m13_b2_r0
	rjmp	m13_b2_r1
	rjmp	m13_b2_r2
	rjmp	m13_b2_r3
	rjmp	m13_b2_r4
	rjmp	m13_b2_r5
	rjmp	m13_b2_r6

rate13_but3:
	rjmp	m13_b3_r0
	rjmp	m13_b3_r1
	rjmp	m13_b3_r2
	rjmp	m13_b3_r3
	rjmp	m13_b3_r4
	rjmp	m13_b3_r5
	rjmp	m13_b3_r6

rate14_but1:
	rjmp	m14_b1_r0
	rjmp	m14_b1_r1
	rjmp	m14_b1_r2
	rjmp	m14_b1_r3
	rjmp	m14_b1_r4
	rjmp	m14_b1_r5
	rjmp	m14_b1_r6

rate14_but2:
	rjmp	m14_b2_r0
	rjmp	m14_b2_r1
	rjmp	m14_b2_r2
	rjmp	m14_b2_r3
	rjmp	m14_b2_r4
	rjmp	m14_b2_r5
	rjmp	m14_b2_r6

rate14_but3:
	rjmp	m14_b3_r0
	rjmp	m14_b3_r1
	rjmp	m14_b3_r2
	rjmp	m14_b3_r3
	rjmp	m14_b3_r4
	rjmp	m14_b3_r5
	rjmp	m14_b3_r6

rate19_but1:
	rjmp	m19_b1_r0
	rjmp	m19_b1_r1
	rjmp	add_power_load
	rjmp	m19_b1_r3

rate19_but2:
	rjmp	m19_b2_r0
	rjmp	m19_b2_r1
	rjmp	sub_power_load
	rjmp	m19_b2_r3

rate19_but3:
	rjmp	m19_b3_r0
	rjmp	m19_b3_r1
	rjmp	m19_b3_r2
	rjmp	m19_b3_r3

rate20_but1:
	rjmp	m20_b1_r0
	rjmp	m20_b1_r1
	rjmp	m20_b1_r2
	rjmp	m20_b1_r3
	rjmp	m20_b1_r4
	rjmp	m20_b1_r5

rate20_but2:
	rjmp	m20_b2_r0
	rjmp	m20_b2_r1
	rjmp	m20_b2_r2
	rjmp	m20_b2_r3
	rjmp	m20_b2_r4
	rjmp	m20_b2_r5

rate20_but3:
	rjmp	m20_b3_r0
	rjmp	m20_b3_r1
	rjmp	m20_b3_r2
	rjmp	m20_b3_r3
	rjmp	m20_b3_r4
	rjmp	m20_b3_r5

rate21_but1:
	rjmp	m21_b1_r0
	rjmp	m21_b1_r1

rate21_but2:
	rjmp	m21_b2_r0
	rjmp	m21_b2_r1

rate21_but3:
	rjmp	m21_b3_r0
	rjmp	m21_b3_r1


rate28_but1:
	rjmp	m28_b1_r0
	rjmp	m28_b1_r1
	rjmp	m28_b1_r2
	rjmp	m28_b1_r3

rate28_but2:
	rjmp	m28_b2_r0
	rjmp	m28_b2_r1
	rjmp	m28_b2_r2
	rjmp	m28_b2_r3

rate28_but3:
	rjmp	m28_b3_r0
	rjmp	m28_b3_r1
	rjmp	m28_b3_r2
	rjmp	m28_b3_r3

rate29_but1:
	rjmp	m29_b1_r0
	rjmp	m29_b1_r1
	rjmp	m29_b1_r2
	rjmp	m29_b1_r3

rate29_but2:
	rjmp	m29_b2_r0
	rjmp	m29_b2_r1
	rjmp	m29_b2_r2
	rjmp	m29_b2_r3

rate29_but3:
	rjmp	m29_b3_r0
	rjmp	m29_b3_r1
	rjmp	m29_b3_r2
	rjmp	m29_b3_r3

rate34_but1:
	ret
	rjmp	m34_b1_r1

rate34_but2:
	ret
	rjmp	m34_b2_r1

rate34_but3:
	rjmp	m34_b3_r0
	rjmp	m34_b3_r1

rate35_but1:
	ret
	rjmp	m35_b1_r1

rate35_but2:
	ret
	rjmp	m35_b2_r1

rate35_but3:
	rjmp	m35_b3_r0
	rjmp	m35_b3_r1

rate36_but1:
	ret
	rjmp	m36_b1_r1

rate36_but2:
	ret
	rjmp	m36_b2_r1

rate36_but3:
	rjmp	m36_b3_r0
	rjmp	m36_b3_r1

rate37_but1:
ret;	rjmp	m37_b1_r0
	rjmp	m37_b1_r1

rate37_but2:
ret;	rjmp	m37_b2_r0
	rjmp	m37_b2_r1

rate37_but3:
	rjmp	m37_b3_r0
	rjmp	m37_b3_r1

;*************************************************************************************************

mode26_but3:
	ldi	Temp1,$c3
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	jmp	add_mode_11

;---------
mode28_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay
	ldi2	ZH,high(rate28_but1),ZL,low(rate28_but1)
	rjmp	rjmp_rate

mode28_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay
	ldi2	ZH,high(rate28_but2),ZL,low(rate28_but2)
	rjmp	rjmp_rate

mode28_but3:
	ldi2	ZH,high(rate28_but3),ZL,low(rate28_but3)
	rjmp	rjmp_rate

mode28_but4:
	call	sub_mode_5
	clr	Rate
	ret

mode28_but5:
	SETB	FlagsLCD,LCD_COM
	ldi	Temp1,$c1		; 
	sts	LcdComWrite,Temp1
	clr	Rate
	jmp	inc_mode

;---------
mode29_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate29_but1),ZL,low(rate29_but1)
	rjmp	rjmp_rate

mode29_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate29_but2),ZL,low(rate29_but2)
	rjmp	rjmp_rate

mode29_but3:
	ldi2	ZH,high(rate29_but3),ZL,low(rate29_but3)
	rjmp	rjmp_rate

mode29_but4:
	call	sub_mode_6
	clr	Rate
	ret

mode29_but5:
	SETB	FlagsLCD,LCD_COM
	clr	Rate
	ldi	Temp1,$c3		; 
	sts	LcdComWrite,Temp1
	clr	Rate
	jmp	dec_mode

;-----------
mode31_but3:
mode32_but3:
mode33_but3:
	ldi	Temp1,$c9
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	jmp	add_mode_3

;-------------------------------------

mode34_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate34_but1),ZL,low(rate34_but1)
	rjmp	rjmp_rate

mode35_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate35_but1),ZL,low(rate35_but1)
	rjmp	rjmp_rate

mode36_but1:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate36_but1),ZL,low(rate36_but1)
	rjmp	rjmp_rate

mode34_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate34_but2),ZL,low(rate34_but2)
	rjmp	rjmp_rate

mode35_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate35_but2),ZL,low(rate35_but2)
	rjmp	rjmp_rate

mode36_but2:
	ldi	Temp1,_TimHoldBut
	sts	CntButDelay,Temp1	;  CntButDelay	
	ldi2	ZH,high(rate36_but2),ZL,low(rate36_but2)
	rjmp	rjmp_rate

mode34_but3:
	ldi2	ZH,high(rate34_but3),ZL,low(rate34_but3)
	rjmp	rjmp_rate

mode35_but3:
	ldi2	ZH,high(rate35_but3),ZL,low(rate35_but3)
	rjmp	rjmp_rate

mode36_but3:
	ldi2	ZH,high(rate36_but3),ZL,low(rate36_but3)
	rjmp	rjmp_rate

mode34_but4:
mode35_but4:
mode36_but4:
	clr	Rate
	ldi	Temp1,$d0
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	jmp	sub_mode_3

;----------

mode37_but1:
	ldi2	ZH,high(rate37_but1),ZL,low(rate37_but1)
	rjmp	rjmp_rate

mode37_but2:
	ldi2	ZH,high(rate37_but2),ZL,low(rate37_but2)
	rjmp	rjmp_rate

mode37_but3:
	ldi2	ZH,high(rate37_but3),ZL,low(rate37_but3)
	rjmp	rjmp_rate

;----------
mode44_but1:
	SETB	FlagsLCD,SOUND_HOUR
	ret

mode44_but2:
	CLRB	FlagsLCD,SOUND_HOUR
	ret

mode45_but1:
	SETB	FlagsLCD,SOUND_BUT
	ret

mode45_but2:
	CLRB	FlagsLCD,SOUND_BUT
	ret

;-----------
mode46_but1:
	lds	Temp1,FlagsRAM
	mov	Temp2,Temp1
	andi	Temp2,(1<<BUTLIGHT_ON)+(1<<BUTLIGHT_BL); 
	breq	m46b1_1
	sbrc	Temp2,BUTLIGHT_BL	;  ,  
	rjmp	m46b1_2
	sbr	Temp1,(1<<BUTLIGHT_BL)
	sts	FlagsRAM,Temp1
	ldio	TCCR2,$1c		;       OC2
	ret
m46b1_1:	sbr	Temp1,(1<<BUTLIGHT_ON)
	sts	FlagsRAM,Temp1
	ldio	TCCR2,$c		;   
	cbi	PORTD,ButLight
	ret
m46b1_2:	cbr	Temp1,(1<<BUTLIGHT_BL)+(1<<BUTLIGHT_ON)
	sts	FlagsRAM,Temp1
	ldio	TCCR2,$c		;   
	sbi	PORTD,ButLight
	ret

mode46_but2:
	lds	Temp1,FlagsRAM
	mov	Temp2,Temp1
	andi	Temp2,(1<<BUTLIGHT_ON)+(1<<BUTLIGHT_BL); 
	breq	m46b2_1
	sbrc	Temp2,BUTLIGHT_BL	;  ,  
	rjmp	m46b2_2
	cbr	Temp1,(1<<BUTLIGHT_ON)+(1<<BUTLIGHT_BL)
	sts	FlagsRAM,Temp1
	ldio	TCCR2,$c		;   
	sbi	PORTD,ButLight
	ret
m46b2_1:	sbr	Temp1,(1<<BUTLIGHT_ON)+(1<<BUTLIGHT_BL)
	sts	FlagsRAM,Temp1
	ldio	TCCR2,$1c		;       OC2
	ret
m46b2_2:	cbr	Temp1,(1<<BUTLIGHT_BL)
	sts	FlagsRAM,Temp1
	ldio	TCCR2,$c		;   
	cbi	PORTD,ButLight
	ret

;--------------------------------------------------

m12_b1_r0:
	SETB	AlrContr11,ALR_ON
	ret

m12_b2_r0:
	CLRB	AlrContr11,ALR_ON
	ret

m12_b1_r1:
	lds	Temp1,AlrHr1
	inc	Temp1
	cpi	Temp1,24
	brne	m12b1r1_1
	clr	Temp1
m12b1r1_1:	sts	AlrHr1,Temp1
	ret

m12_b2_r1:
	lds	Temp1,AlrHr1
	dec	Temp1
	brpl	m12b2r1_1
	ldi	Temp1,23
m12b2r1_1:	sts	AlrHr1,Temp1
	ret

m12_b1_r2:
	lds	Temp1,AlrMin1
	inc	Temp1
	cpi	Temp1,60
	brne	m12b1r2_1
	clr	Temp1
m12b1r2_1:	sts	AlrMin1,Temp1
	ret

m12_b2_r2:
	lds	Temp1,AlrMin1
	dec	Temp1
	brpl	m12b2r2_1
	ldi	Temp1,59
m12b2r2_1:	sts	AlrMin1,Temp1
	ret

m12_b1_r3:
	lds	Temp1,AlrND1
	inc	Temp1
	cpi	Temp1,9
	brne	m12b1r3_1
	clr	Temp1
m12b1r3_1:	sts	AlrND1,Temp1
	ret

m12_b2_r3:
	lds	Temp1,AlrND1
	dec	Temp1
	brpl	m12b2r3_1
	ldi	Temp1,8
m12b2r3_1:	sts	AlrND1,Temp1
	ret

m12_b1_r4:
	SETB	AlrContr11,ALR_LAMP_ON
	ret

m12_b2_r4:
	CLRB	AlrContr11,ALR_LAMP_ON
	ret

m12_b1_r5:
	lds	Temp1,FlagsRAM
	sbrc	Temp1,TEST_MELODY	;  ,  
	jmp	stop_melody

	lds	Temp1,AlrContr12
	inc	Temp1
	cpi	Temp1,100
	brne	m12b1r5_1
	clr	Temp1
m12b1r5_1:	sts	AlrContr12,Temp1

	sts	NumbMelody,Temp1
	SETB	Flags,SOUND_ON
	SETB	FlagsRAM,TEST_MELODY
	ret

m12_b2_r5:
	lds	Temp1,AlrContr12
	dec	Temp1
	brpl	m12b2r5_1
	ldi	Temp1,99
m12b2r5_1:	sts	AlrContr12,Temp1
	ret

m12_b1_r6:
	lds	Temp1,AlrContr11
	mov	Temp2,Temp1
	andi	Temp2,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON); 
	breq	m12b1r6_1
	sbrc	Temp2,ALR_SEARCH_ON	;  ,  
	rjmp	m12b1r6_2
	sbr	Temp1,(1<<ALR_SEARCH_ON)
	sts	AlrContr11,Temp1
	ret
m12b1r6_1:	sbr	Temp1,(1<<ALR_MUS_ON)
	sts	AlrContr11,Temp1
	ret
m12b1r6_2:	cbr	Temp1,(1<<ALR_SEARCH_ON)+(1<<ALR_MUS_ON)
	sts	AlrContr11,Temp1
	ret

m12_b2_r6:
	lds	Temp1,AlrContr11
	mov	Temp2,Temp1
	andi	Temp2,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON); 
	breq	m12b2r6_1
	sbrc	Temp2,ALR_SEARCH_ON	;  ,  
	rjmp	m12b2r6_2
	cbr	Temp1,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON)
	sts	AlrContr11,Temp1
	ret
m12b2r6_1:	sbr	Temp1,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON)
	sts	AlrContr11,Temp1
	ret
m12b2r6_2:	cbr	Temp1,(1<<ALR_SEARCH_ON)
	sts	AlrContr11,Temp1
	ret

m12_b3_r0:
m13_b3_r0:
m14_b3_r0:
	ldi	Temp1,$c1		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m12_b3_r1:
m13_b3_r1:
m14_b3_r1:
	ldi	Temp1,$c4		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m12_b3_r2:
m13_b3_r2:
m14_b3_r2:
	ldi	Temp1,$c6		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m12_b3_r3:
m13_b3_r3:
m14_b3_r3:
	ldi	Temp1,$c8		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m12_b3_r4:
m13_b3_r4:
m14_b3_r4:
	ldi	Temp1,$cb		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m12_b3_r5:
m13_b3_r5:
m14_b3_r5:
	ldi	Temp1,$cd		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m12_b3_r6:
m13_b3_r6:
m14_b3_r6:
	ldi	Temp1,$c0		; 
	sts	LcdComWrite,Temp1
	clr	Rate
	ret

;------------------

m13_b1_r0:
	SETB	AlrContr21,ALR_ON
	ret

m13_b2_r0:
	CLRB	AlrContr21,ALR_ON
	ret

m13_b1_r1:
	lds	Temp1,AlrHr2
	inc	Temp1
	cpi	Temp1,24
	brne	m13b1r1_1
	clr	Temp1
m13b1r1_1:	sts	AlrHr2,Temp1
	ret

m13_b2_r1:
	lds	Temp1,AlrHr2
	dec	Temp1
	brpl	m13b2r1_1
	ldi	Temp1,23
m13b2r1_1:	sts	AlrHr2,Temp1
	ret

m13_b1_r2:
	lds	Temp1,AlrMin2
	inc	Temp1
	cpi	Temp1,60
	brne	m13b1r2_1
	clr	Temp1
m13b1r2_1:	sts	AlrMin2,Temp1
	ret

m13_b2_r2:
	lds	Temp1,AlrMin2
	dec	Temp1
	brpl	m13b2r2_1
	ldi	Temp1,59
m13b2r2_1:	sts	AlrMin2,Temp1
	ret

m13_b1_r3:
	lds	Temp1,AlrND2
	inc	Temp1
	cpi	Temp1,9
	brne	m13b1r3_1
	clr	Temp1
m13b1r3_1:	sts	AlrND2,Temp1
	ret

m13_b2_r3:
	lds	Temp1,AlrND2
	dec	Temp1
	brpl	m13b2r3_1
	ldi	Temp1,8
m13b2r3_1:	sts	AlrND2,Temp1
	ret

m13_b1_r4:
	SETB	AlrContr21,ALR_LAMP_ON
	ret

m13_b2_r4:
	CLRB	AlrContr21,ALR_LAMP_ON
	ret

m13_b1_r5:
	lds	Temp1,FlagsRAM
	sbrc	Temp1,TEST_MELODY	;  ,  
	jmp	stop_melody

	lds	Temp1,AlrContr22
	inc	Temp1
	cpi	Temp1,100
	brne	m13b1r5_1
	clr	Temp1
m13b1r5_1:	sts	AlrContr22,Temp1

	sts	NumbMelody,Temp1
	SETB	Flags,SOUND_ON
	SETB	FlagsRAM,TEST_MELODY
	ret

m13_b2_r5:
	lds	Temp1,AlrContr22
	dec	Temp1
	brpl	m13b2r5_1
	ldi	Temp1,99
m13b2r5_1:	sts	AlrContr22,Temp1
	ret

m13_b1_r6:
	lds	Temp1,AlrContr21
	mov	Temp2,Temp1
	andi	Temp2,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON); 
	breq	m13b1r6_1
	sbrc	Temp2,ALR_SEARCH_ON	;  ,  
	rjmp	m13b1r6_2
	sbr	Temp1,(1<<ALR_SEARCH_ON)
	sts	AlrContr21,Temp1
	ret
m13b1r6_1:	sbr	Temp1,(1<<ALR_MUS_ON)
	sts	AlrContr21,Temp1
	ret
m13b1r6_2:	cbr	Temp1,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON)
	sts	AlrContr21,Temp1
	ret

m13_b2_r6:
	lds	Temp1,AlrContr21
	mov	Temp2,Temp1
	andi	Temp2,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON); 
	breq	m13b2r6_1
	sbrc	Temp2,ALR_SEARCH_ON	;  ,  
	rjmp	m13b2r6_2
	cbr	Temp1,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON)
	sts	AlrContr21,Temp1
	ret
m13b2r6_1:	sbr	Temp1,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON)
	sts	AlrContr21,Temp1
	ret
m13b2r6_2:	cbr	Temp1,(1<<ALR_SEARCH_ON)
	sts	AlrContr21,Temp1
	ret

;-----------

m14_b1_r0:
	SETB	AlrContr31,ALR_ON
	ret

m14_b2_r0:
	CLRB	AlrContr31,ALR_ON
	ret

m14_b1_r1:
	lds	Temp1,AlrHr3
	inc	Temp1
	cpi	Temp1,24
	brne	m14b1r1_1
	clr	Temp1
m14b1r1_1:	sts	AlrHr3,Temp1
	ret

m14_b2_r1:
	lds	Temp1,AlrHr3
	dec	Temp1
	brpl	m14b2r1_1
	ldi	Temp1,23
m14b2r1_1:	sts	AlrHr3,Temp1
	ret

m14_b1_r2:
	lds	Temp1,AlrMin3
	inc	Temp1
	cpi	Temp1,60
	brne	m14b1r2_1
	clr	Temp1
m14b1r2_1:	sts	AlrMin3,Temp1
	ret

m14_b2_r2:
	lds	Temp1,AlrMin3
	dec	Temp1
	brpl	m14b2r2_1
	ldi	Temp1,59
m14b2r2_1:	sts	AlrMin3,Temp1
	ret

m14_b1_r3:
	lds	Temp1,AlrND3
	inc	Temp1
	cpi	Temp1,9
	brne	m14b1r3_1
	clr	Temp1
m14b1r3_1:	sts	AlrND3,Temp1
	ret

m14_b2_r3:
	lds	Temp1,AlrND3
	dec	Temp1
	brpl	m14b2r3_1
	ldi	Temp1,8
m14b2r3_1:	sts	AlrND3,Temp1
	ret

m14_b1_r4:
	SETB	AlrContr31,ALR_LAMP_ON
	ret

m14_b2_r4:
	CLRB	AlrContr31,ALR_LAMP_ON
	ret

m14_b1_r5:
	lds	Temp1,FlagsRAM
	sbrc	Temp1,TEST_MELODY	;  ,  
	jmp	stop_melody

	lds	Temp1,AlrContr32
	inc	Temp1
	cpi	Temp1,100
	brne	m14b1r5_1
	clr	Temp1
m14b1r5_1:	sts	AlrContr32,Temp1

	sts	NumbMelody,Temp1
	SETB	Flags,SOUND_ON
	SETB	FlagsRAM,TEST_MELODY
	ret

m14_b2_r5:
	lds	Temp1,AlrContr32
	dec	Temp1
	brpl	m14b2r5_1
	ldi	Temp1,99
m14b2r5_1:	sts	AlrContr32,Temp1
	ret

m14_b1_r6:
	lds	Temp1,AlrContr31
	mov	Temp2,Temp1
	andi	Temp2,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON); 
	breq	m14b1r6_1
	sbrc	Temp2,ALR_SEARCH_ON	;  ,  
	rjmp	m14b1r6_2
	sbr	Temp1,(1<<ALR_SEARCH_ON)
	sts	AlrContr31,Temp1
	ret
m14b1r6_1:	sbr	Temp1,(1<<ALR_MUS_ON)
	sts	AlrContr31,Temp1
	ret
m14b1r6_2:	cbr	Temp1,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON)
	sts	AlrContr31,Temp1
	ret

m14_b2_r6:
	lds	Temp1,AlrContr31
	mov	Temp2,Temp1
	andi	Temp2,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON); 
	breq	m14b2r6_1
	sbrc	Temp2,ALR_SEARCH_ON	;  ,  
	rjmp	m14b2r6_2
	cbr	Temp1,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON)
	sts	AlrContr31,Temp1
	ret
m14b2r6_1:	sbr	Temp1,(1<<ALR_MUS_ON)+(1<<ALR_SEARCH_ON)
	sts	AlrContr31,Temp1
	ret
m14b2r6_2:	cbr	Temp1,(1<<ALR_SEARCH_ON)
	sts	AlrContr31,Temp1
	ret

;---------

m19_b1_r0:
	lds	Temp1,TimerLoadHour
	inc	Temp1
	sts	TimerLoadHour,Temp1
	sts	TimerLoadHourMem,Temp1
	ret

m19_b2_r0:
	lds	Temp1,TimerLoadHour
	dec	Temp1
	sts	TimerLoadHour,Temp1
	sts	TimerLoadHourMem,Temp1
	ret

m19_b1_r1:
	lds	Temp1,TimerLoadMin
	inc	Temp1
	cpi	Temp1,60
	brne	m19b1r1_1
	clr	Temp1
m19b1r1_1:	sts	TimerLoadMin,Temp1
	sts	TimerLoadMinMem,Temp1
	ret

m19_b2_r1:
	lds	Temp1,TimerLoadMin
	dec	Temp1
	brpl	m19b2r1_1
	ldi	Temp1,59
m19b2r1_1:	sts	TimerLoadMin,Temp1
	sts	TimerLoadMinMem,Temp1
	ret

m19_b1_r3:
m19_b2_r3:

	lds	Temp1,TimerLoadFlag
	sbrs	Temp1,TIM_ONE_EN	; , 
	rjmp	m19b1r3_2
	sbrc	Temp1,TIM_LOAD_CYCLE	;  , 
	rjmp	m19b1r3_3
	sbrc	Temp1,TIM_LOAD_ONOFF	; , 
	rjmp	m19b1r3_4
	sbr	Temp1,(1<<TIM_ONE_EN)+(1<<TIM_LOAD_ONOFF)
	cbr	Temp1,(1<<TIM_LOAD_CYCLE)
	rjmp	m19b1r3_1
m19b1r3_4:	sbr	Temp1,(1<<TIM_ONE_EN)+(1<<TIM_LOAD_ONOFF)+(1<<TIM_LOAD_CYCLE)
	rjmp	m19b1r3_1
m19b1r3_3:	cbr	Temp1,(1<<TIM_LOAD_ONOFF)+(1<<TIM_LOAD_CYCLE)+(1<<TIM_ONE_EN)
	rjmp	m19b1r3_1
m19b1r3_2:	sbr	Temp1,(1<<TIM_ONE_EN)
	cbr	Temp1,(1<<TIM_LOAD_ONOFF)+(1<<TIM_LOAD_CYCLE)+(1<<TSTAT_EN)+(1<<TPROG_EN)
m19b1r3_1:	sts	TimerLoadFlag,Temp1
	ret

m19_b3_r0:
	ldi	Temp1,$8b		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m19_b3_r1:
	ldi	Temp1,$c5		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m19_b3_r2:
	ldi	Temp1,$ca		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m19_b3_r3:
	ldi	Temp1,$88		; 
	sts	LcdComWrite,Temp1
	clr	Rate
	ret

;-----------------------

m20_b1_r0:
	jmp	inc_point_16

m20_b2_r0:
	dec	Point
	brpl	m20b2r0_1
	ldi	Temp1,15
	mov	Point,Temp1
m20b2r0_1:	mov	DataL,Point
	clr	DataH
	ldi	Temp1,5
	call	mul_16x8
	ldi2	XL,low(_TPoint0),XH,high(_TPoint0)
	add	XL,DataL
	adc	XH,DataH
	jmp	copy_point

m20_b1_r1:
	lds	Temp1,SetTimHour
	inc	Temp1
	cpi	Temp1,24
	brne	m20b1r1_1
	clr	Temp1
m20b1r1_1:	sts	SetTimHour,Temp1
	ret

m20_b2_r1:
	lds	Temp1,SetTimHour
	dec	Temp1
	brpl	m20b2r1_1
	ldi	Temp1,23
m20b2r1_1:	sts	SetTimHour,Temp1
	ret

m20_b1_r2:
	lds	Temp1,SetTimMin
	inc	Temp1
	cpi	Temp1,60
	brne	m20b1r2_1
	clr	Temp1
m20b1r2_1:	sts	SetTimMin,Temp1
	ret

m20_b2_r2:
	lds	Temp1,SetTimMin
	dec	Temp1
	brpl	m20b2r2_1
	ldi	Temp1,59
m20b2r2_1:	sts	SetTimMin,Temp1
	ret

m20_b1_r3:
	lds	Temp1,SetTimDay
	mov	Temp2,Temp1
	andi	Temp1,$e0		; 
	andi	Temp2,$1f		; 
	inc	Temp2
	cpi	Temp2,9
	brne	m20b1r3_1
	clr	Temp2
m20b1r3_1:	or	Temp1,Temp2
	sts	SetTimDay,Temp1
	ret

m20_b2_r3:
	lds	Temp1,SetTimDay
	mov	Temp2,Temp1
	andi	Temp1,$e0		; 
	andi	Temp2,$1f		; 
	dec	Temp2
	brpl	m20b2r3_1
	ldi	Temp2,8
m20b2r3_1:	or	Temp1,Temp2
	sts	SetTimDay,Temp1
	ret

m20_b1_r4:
	lds	Temp1,SetTimPowL
	lds	Temp2,SetTimPowH
	subi	Temp1,low(_Step)
	sbci	Temp2,high(_Step)	;16  
	ldi2	Temp3,low(_Max),Temp4,high(_Max)
	cp	Temp3,Temp1
	cpc	Temp4,Temp2		;16  
	brlt	m20b1r4_1		;   >  , 
	ldi2	Temp2,high(_Max),Temp1,low(_Max)
m20b1r4_1:	sts	SetTimPowL,Temp1
	sts	SetTimPowH,Temp2
	SETB	FlagsButton,MULTI
	ret

m20_b2_r4:
	lds	Temp1,SetTimPowL
	lds	Temp2,SetTimPowH
	subi	Temp1,low(-_Step)
	sbci	Temp2,high(-_Step)	;16  
	cpi	Temp1,low(_Min)
	ldi	Temp3,high(_Min)	;16  
	cpc	Temp2,Temp3
	brlo	m20b2r4_1		;   <  , 
	ldi2	Temp2,high(_Min),Temp1,low(_Min)
m20b2r4_1:	sts	SetTimPowL,Temp1
	sts	SetTimPowH,Temp2
	SETB	FlagsButton,MULTI
	ret

m20_b1_r5:
m20_b2_r5:
	lds	Temp1,SetTimDay
	sbrs	Temp1,7		; , 
	rjmp	m20b1r5_2
	sbrc	Temp1,6		;  , 
	rjmp	m20b1r5_3
	sbrc	Temp1,5		; , 
	rjmp	m20b1r5_4
	sbr	Temp1,(1<<7)+(1<<5)
	cbr	Temp1,(1<<6)
	rjmp	m20b1r5_1
m20b1r5_4:	sbr	Temp1,(1<<7)+(1<<5)+(1<<6)
	rjmp	m20b1r5_1
m20b1r5_3:	cbr	Temp1,(1<<5)+(1<<6)+(1<<7)
	rjmp	m20b1r5_1
m20b1r5_2:	sbr	Temp1,(1<<7)
	cbr	Temp1,(1<<5)+(1<<6)
m20b1r5_1:	sts	SetTimDay,Temp1
	ret

m20_b3_r0:
	ldi	Temp1,$89		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m20_b3_r1:
	ldi	Temp1,$8c		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ldi2	ZL,low(SetTimHour),ZH,high(SetTimHour)
	jmp	write_point

m20_b3_r2:
	ldi	Temp1,$8e		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ldi2	ZL,low(SetTimMin),ZH,high(SetTimMin)
	jmp	write_point

m20_b3_r3:
	ldi	Temp1,$c5		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ldi2	ZL,low(SetTimDay),ZH,high(SetTimDay)
	jmp	write_point

m20_b3_r4:
	ldi	Temp1,$ca		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ldi2	ZL,low(SetTimPowL),ZH,high(SetTimPowL)
	call	write_point
	ldi2	ZL,low(SetTimPowH),ZH,high(SetTimPowH)
	jmp	write_point

m20_b3_r5:
	ldi	Temp1,$86		; 
	sts	LcdComWrite,Temp1
	ldi2	ZL,low(SetTimDay),ZH,high(SetTimDay)
	call	write_point
	clr	Rate
	jmp	inc_point_16

;------------------------------

m21_b1_r0:
	lds	Temp3,SetTermostatL
	lds	Temp4,SetTermostatH
	ldi2	Temp1,low(400),Temp2,high(400)
	SKBC	FlagsButton,Multi
	rjmp	m21b1r0_2
	subi	Temp3,low(-5)
	sbci	Temp4,high(-5)
	rjmp	m21b1r0_3
m21b1r0_2:	subi	Temp3,low(-50)
	sbci	Temp4,high(-50)
m21b1r0_3:	cp	Temp3,Temp1
	cpc	Temp4,Temp2
	brlo	m21b1r0_1
	clr	Temp3
	clr	Temp4
m21b1r0_1:	sts	SetTermostatL,Temp3
	sts	SetTermostatH,Temp4
	ret

m21_b2_r0:
	lds	Temp3,SetTermostatL
	lds	Temp4,SetTermostatH
	SKBC	FlagsButton,Multi
	rjmp	m21b2r0_2
	subi	Temp3,low(5)
	sbci	Temp4,high(5)
	rjmp	m21b2r0_3
m21b2r0_2:	subi	Temp3,low(50)
	sbci	Temp4,high(50)
m21b2r0_3:	brge	m21b1r0_1
	ldi2	Temp3,low(395),Temp4,high(395)
m21b2r0_1:	sts	SetTermostatL,Temp3
	sts	SetTermostatH,Temp4
	ret

m21_b1_r1:
m21_b2_r1:
	lds	Temp1,TimerLoadFlag
	sbrs	Temp1,TSTAT_EN	; , 
	rjmp	m21b1r1_2
	sbrc	Temp1,TSTAT_ONOFF	; , 
	rjmp	m21b1r1_4
	sbr	Temp1,(1<<TSTAT_EN)+(1<<TSTAT_ONOFF)
	rjmp	m21b1r1_1
m21b1r1_4:	cbr	Temp1,(1<<TSTAT_EN)+(1<<TSTAT_ONOFF)
	rjmp	m21b1r1_1
m21b1r1_2:	sbr	Temp1,(1<<TSTAT_EN)
	cbr	Temp1,(1<<TSTAT_ONOFF)+(1<<TPROG_EN)+(1<<TIM_ONE_EN)
m21b1r1_1:	sts	TimerLoadFlag,Temp1
	ret

m21_b3_r0:
	ldi	Temp1,$c9		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m21_b3_r1:
	ldi	Temp1,$c2		; 
	sts	LcdComWrite,Temp1
	clr	Rate
	ret

;------------------------------
m28_b1_r0:
	lds	Temp1,Hour
	inc	Temp1
	cpi	Temp1,24
	brne	m28b1r0_1
	clr	Temp1
m28b1r0_1:	sts	Hour,Temp1
	ret

m28_b2_r0:
	lds	Temp1,Hour
	dec	Temp1
	brpl	m28b2r0_1
	ldi	Temp1,23
m28b2r0_1:	sts	Hour,Temp1
	ret

m28_b1_r1:
	lds	Temp1,Minute
	inc	Temp1
	cpi	Temp1,60
	brne	m28b1r1_1
	clr	Temp1
m28b1r1_1:	sts	Minute,Temp1
	ret

m28_b2_r1:
	lds	Temp1,Minute
	dec	Temp1
	brpl	m28b2r1_1
	ldi	Temp1,59
m28b2r1_1:	sts	Minute,Temp1
	ret

m28_b1_r2:
m28_b2_r2:
	clr	Second
	ret

m28_b1_r3:
	lds	Temp1,NameDays
	inc	Temp1
	cpi	Temp1,7
	brne	m28b1r3_1
	clr	Temp1
m28b1r3_1:	sts	NameDays,Temp1
	ret

m28_b2_r3:
	lds	Temp1,NameDays
	dec	Temp1
	brpl	m28b2r3_1
	ldi	Temp1,6
m28b2r3_1:	sts	NameDays,Temp1
	ret

m28_b3_r0:
	ldi	Temp1,$c6		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m28_b3_r1:
	ldi	Temp1,$c9		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m28_b3_r2:
	ldi	Temp1,$cc		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m28_b3_r3:
	ldi	Temp1,$c1		; 
	sts	LcdComWrite,Temp1
	clr	Rate
	call	inc_mode
	ret

;--------
m29_b1_r0:
	ldi2	YH,high(Day),YL,low(Day)
	clr	Temp1
	ldi2	ZH,high(date*2),ZL,low(date*2)	; -     
	ldd	Temp2,Y+1		;  
	add	ZL,Temp2		;    
	adc	ZH,Temp1		;Temp1=0
	lpm	Temp3,Z		;    .
	ld	Temp1,Y		;  
	cpi	Temp2,2		; - ?
	brne	m29b1r0_2		;
				;
	ldd	Temp2,Y+2		;  
	andi	Temp2,3		;   
	brne	m29b1r0_2		;   ,  
	inc	Temp3		; 29- 
m29b1r0_2:	inc	Temp1		; 
	cp	Temp1,Temp3
	brne	m29b1r0_1
	ldi	Temp1,1
m29b1r0_1:	st	Y,Temp1
	ret

m29_b2_r0:
	ldi2	YH,high(Day),YL,low(Day)
	clr	Temp1
	ldi2	ZH,high(date*2),ZL,low(date*2)	; -     
	ldd	Temp2,Y+1		;  
	add	ZL,Temp2		;    
	adc	ZH,Temp1		;Temp1=0
	lpm	Temp3,Z		;    .
	ld	Temp1,Y		;  
	cpi	Temp2,2		; - ?
	brne	m29b2r0_2		;
				;
	ldd	Temp2,Y+2		;  
	andi	Temp2,3		;   
	brne	m29b2r0_2		;   ,  
	inc	Temp3		; 29- 
m29b2r0_2:	dec	Temp1		; 
	brne	m29b2r0_1
	dec	Temp3
	mov	Temp1,Temp3
m29b2r0_1:	st	Y,Temp1
	ret

m29_b1_r1:
	lds	Temp1,Month
	inc	Temp1
	cpi	Temp1,13
	brne	m29b1r1_1
	ldi	Temp1,1
m29b1r1_1:	sts	Month,Temp1
	ret

m29_b2_r1:
	lds	Temp1,Month
	dec	Temp1
	brne	m29b2r1_1
	ldi	Temp1,12
m29b2r1_1:	sts	Month,Temp1
	ret

m29_b1_r2:
	lds	Temp1,Year
	inc	Temp1
	sts	Year,Temp1
	ret

m29_b2_r2:
	lds	Temp1,Year
	dec	Temp1
	sts	Year,Temp1
	ret

m29_b1_r3:
	SETB	FlagsLCD,SUM_ON
	ret

m29_b2_r3:
	CLRB	FlagsLCD,SUM_ON
	ret

m29_b3_r0:
	ldi	Temp1,$c4		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m29_b3_r1:
	ldi	Temp1,$c7		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m29_b3_r2:
	ldi	Temp1,$cb		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m29_b3_r3:
	ldi	Temp1,$c3		; 
	sts	LcdComWrite,Temp1
	clr	Rate
	call	dec_mode
	ret

;--------------

m34_b1_r1:
m35_b1_r1:
m36_b1_r1:
	lds	XL,TempTermL
	lds	XH,TempTermH
	SKBC	FlagsButton,MULTI
	rjmp	m34b1r1_3
	ldi2	Temp1,low(1),Temp2,high(1)
	rjmp	m34b1r1_2
m34b1r1_3:	ldi2	Temp1,low(10),Temp2,high(10)

m34b1r1_2:	add	XL,Temp1
	adc	XH,Temp2
	cpi	XL,low(499)
	ldi	Temp1,high(499)
	cpc	XH,Temp1
	brlo	m35b1r1_1		; ,  
	clr	XL
	clr	XH
m35b1r1_1:	sts	TempTermL,XL
	sts	TempTermH,XH
	ret

m34_b2_r1:
m35_b2_r1:
m36_b2_r1:
	lds	XL,TempTermL
	lds	XH,TempTermH
	SKBC	FlagsButton,MULTI
	rjmp	m34b2r1_3
	ldi2	Temp1,low(1),Temp2,high(1)
	rjmp	m34b2r1_2
m34b2r1_3:	ldi2	Temp1,low(10),Temp2,high(10)

m34b2r1_2:	clr	Temp3
	clr	Temp4
	sub	XL,Temp1
	sbc	XH,Temp2
	cp	Temp1,Temp3
	cpc	Temp2,Temp4
	brcc	m35b2r1_1		; >=0,  
	ldi2	XL,low(500),XH,high(500)
m35b2r1_1:	sts	TempTermL,XL
	sts	TempTermH,XH
	ret

m34_b3_r0:		; U0
	lds	Temp1,DataTerm1L
	lds	Temp2,DataTerm1H
	rjmp	m36_b3_r0_1

m35_b3_r0:
	lds	Temp1,DataTerm2L
	lds	Temp2,DataTerm2H
	rjmp	m36_b3_r0_1

m36_b3_r0:

	lds	Temp1,DataTerm3L
	lds	Temp2,DataTerm3H
m36_b3_r0_1:sts	TempTerm0L,Temp1
	sts	TempTerm0H,Temp2
	ldi	Temp1,$cd		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m34_b3_r1:
	lds	Temp1,DataTerm1L
	lds	Temp2,DataTerm1H
	ldi2	XL,low(_TermK1L),XH,high(_TermK1L)
	rjmp	mbr34_3_1_1

m35_b3_r1:
	lds	Temp1,DataTerm2L
	lds	Temp2,DataTerm2H
	ldi2	XL,low(_TermK2L),XH,high(_TermK2L)
	rjmp	mbr34_3_1_1

m36_b3_r1:
		; :

	lds	Temp1,DataTerm3L
	lds	Temp2,DataTerm3H
	ldi2	XL,low(_TermK3L),XH,high(_TermK3L)
mbr34_3_1_1:
	push	XL		;   
	push	XH
	lds	Temp3,TempTerm0L
	lds	Temp4,TempTerm0H
	sub	Temp1,Temp3
	sbc	Temp2,Temp4		;Ut-U0

	movw	YL,Temp1		; (Ut-U0)  Y
	clr	Temp5
	sts	DataMat4,Temp5
	sts	DataMat3,Temp5
	sts	DataMat8,Temp5
	sts	DataMat7,Temp5
	lds	Temp5,TempTermL
	lds	Temp6,TempTermH
	sts	DataMat2,Temp6
	sts	DataMat1,Temp5	;
	sts	DataMat6,Temp2
	sts	DataMat5,Temp1	;
	call	div32_32_32s	;t/(Ut-U0)

	lds	Temp1,DataMat1
	call	write_eeprom	; -
	adiw	XL,1
	lds	Temp1,DataMat2
	call	write_eeprom	; -
	adiw	XL,1

	lds	DataML,DataMat5
	lds	DataMH,DataMat6	;1 (  )
	ldi2	Temp1,low(_NumbDec),Temp2,high(_NumbDec)
	movw	DataL,Temp1
	call	muls16x16_32	;t/(Ut-U0)*10000

	sts	DataMat1,DataL
	sts	DataMat2,DataML	;
	sts	DataMat3,DataMH
	sts	DataMat4,DataH
	clr	Temp1
	sts	DataMat8,Temp1
	sts	DataMat7,Temp1
	sts	DataMat5,YL		;
	sts	DataMat6,YH
	call	div32_32_32s	;(t/(Ut-U0)*10000)/(Ut-U0) -  

	lds	Temp1,DataMat1
	call	write_eeprom	; -
	adiw	XL,1
	lds	Temp1,DataMat2
	call	write_eeprom	; -

		; :

	pop	XH
	pop	XL
	lds	DataL,TempTerm0L
	lds	DataH,TempTerm0H
;	call	calcul_B

	mov	Temp1,DataL
	call	write_eeprom	; -
	adiw	XL,1
	mov	Temp1,DataML
	call	write_eeprom	; -
	adiw	XL,1
	mov	Temp1,DataMH
	call	write_eeprom	; -
	adiw	XL,1
	mov	Temp1,DataH
	call	write_eeprom	; -

	ldi	Temp1,$d0
	sts	LcdComWrite,Temp1
	SETB	FlagsLCD,LCD_COM
	clr	Rate
	jmp	sub_mode_3

;-----------

m37_b1_r1:
	lds	Temp1,FlagsRAM
	mov	Temp2,Temp1
	andi	Temp2,(1<<BACKLIGHT_ON)+(1<<BACKLIGHT_AUTO); 
	breq	m37b1r1_1
	sbrc	Temp2,BACKLIGHT_AUTO	;  ,  
	rjmp	m37b1r1_2
	sbr	Temp1,(1<<BACKLIGHT_AUTO)
	sts	FlagsRAM,Temp1
	ret
m37b1r1_1:	sbr	Temp1,(1<<BACKLIGHT_ON)
	sts	FlagsRAM,Temp1
	sbi	PORTD,BackLight
	ret
m37b1r1_2:	cbr	Temp1,(1<<BACKLIGHT_ON)+(1<<BACKLIGHT_AUTO)
	sts	FlagsRAM,Temp1
	cbi	PORTD,BackLight
	ret

m37_b2_r1:
	lds	Temp1,FlagsRAM
	mov	Temp2,Temp1
	andi	Temp2,(1<<BACKLIGHT_ON)+(1<<BACKLIGHT_AUTO); 
	breq	m37b2r1_1
	sbrc	Temp2,BACKLIGHT_AUTO	;  ,  
	rjmp	m37b2r1_2
	cbr	Temp1,(1<<BACKLIGHT_ON)+(1<<BACKLIGHT_AUTO)
	sts	FlagsRAM,Temp1
	cbi	PORTD,BackLight
	ret
m37b2r1_1:	sbr	Temp1,(1<<BACKLIGHT_ON)+(1<<BACKLIGHT_AUTO)
	sts	FlagsRAM,Temp1
	ret
m37b2r1_2:	cbr	Temp1,(1<<BACKLIGHT_AUTO)
	sts	FlagsRAM,Temp1
	sbi	PORTD,BackLight
	ret

m37_b3_r0:
	ldi	Temp1,$cb		; 
	sts	LcdComWrite,Temp1
	inc	Rate
	ret

m37_b3_r1:
	ldi	Temp1,$c3		; 
	sts	LcdComWrite,Temp1
	clr	Rate
	ret

;-----------------------------------------------------------------------------------------------------------


write_videoram:			;/   (   )
	; 4-    1 ,  3,  2  4

	cli
	ldi2	XH,high(LcdRAM1),XL,low(LcdRAM1); 1  
	ldi	Temp1,_LcdSimb	;    
wvr1:	lpm	Temp2,Z+		;  FLASH  Temp2
	st	X+,Temp2		;    FLASH
	dec	Temp1
	brne	wvr1		;   <>0,  
	sei
	ret

write_vr_1line:			;/    1 

	cli
	ldi2	XH,high(LcdRAM1),XL,low(LcdRAM1); 1  
	ldi	Temp1,_LcdSimb/2	;    1  
wvr1l1:	lpm	Temp2,Z+		;  FLASH  Temp2
	st	X+,Temp2		;    FLASH
	dec	Temp1
	brne	wvr1l1		;   <>0,  
	sei
	ret

write_vr_2line:			;/    2 

	cli
	ldi2	XH,high(LcdRAM2),XL,low(LcdRAM2); 2  
	ldi	Temp1,_LcdSimb/2	;    2  
wvr2l1:	lpm	Temp2,Z+		;  FLASH  Temp2
	st	X+,Temp2		;    FLASH
	dec	Temp1
	brne	wvr2l1		;   <>0,  
	sei
	ret

add_power_load:			;/   

	ldi	Temp1,40
	sts	CntHoldInd,Temp1

	ldi2	ZH,high(Adjust2H),ZL,low(Adjust2H)
	rjmp	add_power

sub_power_lamp:			;/   

	ldi	Temp1,_TimIndHold
	sts	CntHoldInd,Temp1

	SKBS	Flags,LAMP_ON	;   ,  
	ret
	ldi2	ZH,high(AdjustMem1H),ZL,low(AdjustMem1H)

sub_power:			;/  

	ld	Temp1,Z
	ldd	Temp2,Z+1
	subi	Temp2,low(-_Step)
	sbci	Temp1,high(-_Step)	;16  
	cpi	Temp2,low(_Min)
	ldi	Temp3,high(_Min)	;16  
	cpc	Temp1,Temp3
	brlo	spl1		;   <  , 
	ldi2	Temp1,high(_Min),Temp2,low(_Min)
spl1:	st	Z,Temp1
	std	Z+1,Temp2
	SETB	FlagsButton,MULTI
	ret


sub_power_load:			;/   

	ldi	Temp1,40
	sts	CntHoldInd,Temp1

	ldi2	ZH,high(Adjust2H),ZL,low(Adjust2H)
	rjmp	sub_power


add_power_lamp:			;/   

	ldi	Temp1,_TimIndHold
	sts	CntHoldInd,Temp1

	SKBS	Flags,LAMP_ON	;   ,  
	ret
	ldi2	ZH,high(AdjustMem1H),ZL,low(AdjustMem1H)

add_power:			;/  

	ld	Temp1,Z
	ldd	Temp2,Z+1
	subi	Temp2,low(_Step)
	sbci	Temp1,high(_Step)	;16  
	ldi2	Temp3,low(_Max),Temp4,high(_Max)
	cp	Temp3,Temp2
	cpc	Temp4,Temp1		;16  
	brlt	apl1		;   >  , 
	ldi2	Temp1,high(_Max),Temp2,low(_Max)
apl1:	st	Z,Temp1
	std	Z+1,Temp2
	SETB	FlagsButton,MULTI
	ret


onoff_lamp:			;/ / 

	push	Temp1

	ldi	Temp1,_TimIndHold
	sts	CntHoldInd,Temp1

	SKBS	Flags,LAMP_ON	;,   
	rjmp	on_lamp1
	CLRB	Flags,LAMP_ON	; 

	pop	Temp1
	ret
on_lamp1:	
	SETB	Flags,LAMP_ON	; 
	ldi	Temp1,$7f
	sts	Adjust1H,Temp1
	ldi	Temp1,$ff
	sts	Adjust1L,Temp1	;   

	pop	Temp1
	ret

onoff_load:			;/ / 

	ldi	Temp1,_TimIndHold
	sts	CntHoldInd,Temp1

	SKBS	Flags,LOAD_ON	;,    
	rjmp	load_onn		; 

load_off:		;/  

	CLRB	Flags,LOAD_ON	; 
	ldi	Temp1,2
	cp	Temp1,Mode
	breq	ldonofret
	SETB	Flags,SOUND_ON
	SETB	FlagsLCD,SOUND_SHORT

ldonofret:	ret

load_onn:		;/  

	SETB	Flags,LOAD_ON
	ldi	Temp1,2
	cp	Temp1,Mode
	breq	ldonofret
	SETB	Flags,SOUND_ON	; 
	SETB	FlagsLCD,SOUND_SHORT
	ret


		;/       

set_mode_0:	CLRB	FlagsLCD,LCD_COM
	CLRB	FlagsLCD,SOUND_SHORT
	CLRB	Flags,BEEPING
	CLRB	Flags,SOUND_ON
	lds	Temp1,FlagsRAM
	cbr	Temp1,(1<<SOUND_PAUSE)
	sts	FlagsRAM,Temp1
	ldio	TCCR0,0
	chnc	TIMSK,(1<<OCIE0)
	cbi	PORTB,ZP
	clr	Mode
	sts	NumbNoteMemL,Mode
	sts	NumbNoteMemH,Mode
	sts	CntBeep,Mode
	ldio	ADCSRA,$ce		; ,  ,  115
	ret

set_mode_5:	ldi	Temp1,5
	rjmp	set_mode

set_mode_8:	ldi	Temp1,8
	rjmp	set_mode

set_mode_22:	ldi	Temp1,22
	rjmp	set_mode

set_mode:
	mov	Mode,Temp1
	ldi	Temp1,_TimIndRet
	sts	CntHoldInd,Temp1
	clr	Rate
	ret

inc_mode:	inc	Mode
	ldi	Temp1,_TimIndRet
	sts	CntHoldInd,Temp1
	ret

add_mode_2:	ldi	Temp1,2
	rjmp	add_mode

add_mode_3:	ldi	Temp1,3
	rjmp	add_mode

add_mode_4:	ldi	Temp1,4
	rjmp	add_mode

add_mode_5:	ldi	Temp1,5
	rjmp	add_mode

add_mode_6:	ldi	Temp1,6
	rjmp	add_mode

add_mode_7:	ldi	Temp1,7
	rjmp	add_mode

add_mode_8:	ldi	Temp1,8
	rjmp	add_mode

add_mode_11:ldi	Temp1,11
	rjmp	add_mode

add_mode:
	add	Mode,Temp1
	ldi	Temp1,_TimIndRet
	sts	CntHoldInd,Temp1
	clr	Rate
	ret

dec_mode:	dec	Mode
	ldi	Temp1,_TimIndRet
	sts	CntHoldInd,Temp1
	clr	Rate
	ret

sub_mode_2:	ldi	Temp1,2
	rjmp	sub_mode

sub_mode_3:	ldi	Temp1,3
	rjmp	sub_mode

sub_mode_4:	ldi	Temp1,4
	rjmp	sub_mode

sub_mode_5:	ldi	Temp1,5
	rjmp	sub_mode

sub_mode_6:	ldi	Temp1,6
	rjmp	sub_mode

sub_mode_7:	ldi	Temp1,7
	rjmp	sub_mode

sub_mode_8:	ldi	Temp1,8
	rjmp	sub_mode

sub_mode_11:ldi	Temp1,11
	rjmp	sub_mode

sub_mode_12:ldi	Temp1,12
	rjmp	sub_mode

sub_mode_13:ldi	Temp1,13
	rjmp	sub_mode

sub_mode_14:ldi	Temp1,14
	rjmp	sub_mode

sub_mode:
	sub	Mode,Temp1
	ldi	Temp1,_TimIndRet
	sts	CntHoldInd,Temp1
	clr	Rate
	ret

ret_mode_0:
	ldi	Temp1,_TimIndHold
	sts	CntHoldInd,Temp1
	ret

termo_conv:			;/   , : Z-U,X--
	CLRB	Flags, NEGATIVE	;   
	ld	DataL, Z
	ldd	DataH, Z+1		;  Z   
	sbrs	DataH, 7		;   , 
	rjmp	trmcnv_4
	SETB	Flags, NEGATIVE	;   
	com	DataL
	com	DataH
trmcnv_4:	mov	Temp2, DataL
	ldi	Temp1, 4
trmcnv_1:	lsr	DataH
	ror	DataL		;   4 -   
	dec	Temp1
	brne	trmcnv_1
	ldi	Temp1, 100
	call	mul_16x8		;   100
	clr	Temp1
	clr	Temp3
	andi	Temp2, $f		; 
	breq	trmcnv_3
trmcnv_2:	subi	Temp1, low(-625)	; 
	sbci	Temp3, high(-625)
	dec	Temp2
	brne	trmcnv_2

	clr	Temp2
	sts	DataMat1, Temp1
	sts	DataMat2, Temp3
	sts	DataMat3, Temp2
	sts	DataMat4, Temp2
	ldi	Temp1, 100
	sts	DataMat5, Temp1
	sts	DataMat6, Temp2
	sts	DataMat7, Temp2
	sts	DataMat8, Temp2
	call	div32_32_32s
	lds	Temp1, DataMat1
	lds	Temp2, DataMat2
	add	DataL, Temp1
	adc	DataH, Temp2
	ldi	Temp1, 5
	clr	Temp2
	add	DataL, Temp1	;
	adc	DataH, Temp2
trmcnv_3:	sts	fASCIIL, DataL	;   
	sts	fASCIIH, DataH
	jmp	bin2ASCII16


read_eeprom:			;/   EEPROM

	sbic	EECR,EEWE		;   
	rjmp	read_eeprom
	out	EEARH,XH		;  EEPROM ( )
	out	EEARL,XL		;  EEPROM ( )
	sbi	EECR,EERE		; 
	in	Temp1,EEDR		; 
	ret

write_eeprom:			;/   EEPROM

	sbic	EECR,EEWE		;   
	rjmp	write_eeprom
	cli
	out	EEARH,XH		;  EEPROM ( )
	out	EEARL,XL		;  EEPROM ( )
	out	EEDR,Temp1		;    
	sbi	EECR,EEMWE
	sbi	EECR,EEWE		; 
	sei
	ret


ind_time:			;/  

	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ldi2	XH,high(Hour),XL,low(Hour)
	ldi2	ZH,high(LcdRAM1),ZL,low(LcdRAM1); 

	ld	Temp1,X		;      ASCII
	st	Y+,Temp1
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1		;   
	ld	Temp1,Y+
	st	Z+,Temp1		;   
	sbrc	Second,2		;  2   ,  
	ldi	Temp1,':'
	sbrs	Second,2		;  2   ,  
	ldi	Temp1,' '
	st	Z+,Temp1		; 
	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ld	Temp1,-X		;      ASCII
	st	Y+,Temp1
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1		;   
	ld	Temp1,Y
	st	Z+,Temp1		;   
	ldi2	XH,high(NameDays),XL,low(NameDays)
	movw	YL,ZL
	ldi2	ZH,high(day_n*2),ZL,low(day_n*2)
	ld	Temp1,X+		;   
	clr	Temp2
	lsl	Temp1
	rol	Temp2
	add	ZL,Temp1
	adc	ZH,Temp2
	lpm	Temp1,Z+		;  
	st	Y+,Temp1
	lpm	Temp1,Z		;  
	st	Y+,Temp1
	movw	ZL,YL
	ldi	Temp1,3
	mov	Cnt,Temp1
imd01:	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ld	Temp1,X+		;  (,)    ASCII
	st	Y+,Temp1
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	Z+,Temp1		;   (,)
	ld	Temp1,Y+
	st	Z+,Temp1		;   (,)
	ldi	Temp1,'-'
	st	Z+,Temp1		; 
	dec	Cnt
	brne	imd01
	ldi	Temp1,' '
	st	-Z,Temp1
	lds	Temp4,TimerLoadFlag
	sbrc	Temp4,TIM_ONE_EN
	rjmp	imd03
	sbrc	Temp4,TPROG_EN
	rjmp	imd04
	sbrc	Temp4,TSTAT_EN
	rjmp	imd05

imd06:	ldi	Temp1,$ed
	ldi	Temp3,3
	ldi2	YH,high(AlrContr11),YL,low(AlrContr11)
imd02:	ld	Temp2,Y
	sbrc	Temp2,ALR_ON		;  ,  
	st	Z,Temp1
	adiw	YL,5
	dec	Temp3
	brne	imd02
	ret

imd03:	ldi	Temp1,$d7
	rjmp	imd07
imd04:	ldi	Temp1,$ce
	rjmp	imd07
imd05:	ldi	Temp1,$fa
imd07:	sbrc	Second,2
	rjmp	imd06
	st	Z,Temp1
	ret

NN_power:			;/   

	ld	DataH,Z+
	ld	DataL,Z
	ldi2	Temp1,high($9aaf/100),Temp2,low($9aaf/100)
	clr	Temp3
nn_pow_loop:
	inc	Temp3
	sub	DataL,Temp2
	sbc	DataH,Temp1
	brpl	nn_pow_loop
	dec	Temp3
	ldi	Temp1,100
	sub	Temp1,Temp3
	clr	Temp3
	sts	fASCIIL,Temp1
	sts	fASCIIH,Temp3
	call	bin2ASCII16
	ret

ind_alarm:			;/    

	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ldi2	XH,high(LcdRAM2),XL,low(LcdRAM2); 

	ldd	Temp2,Z+3		;  
	sbrs	Temp2,ALR_ON	;  ,  
	rjmp	ind_alr1
	ldi	Temp1,$ed
	st	X+,Temp1
	rjmp	ind_alr2
ind_alr1:	adiw	XL,1
ind_alr2:	ld	Temp1,Z+		;      ASCII
	st	Y+,Temp1
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	X+,Temp1		;   
	ld	Temp1,Y+
	st	X+,Temp1		;   
	ldi	Temp1,':'		;
	st	X+,Temp1

	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	ld	Temp1,Z+		;      ASCII
	st	Y+,Temp1
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	X+,Temp1		;   
	ld	Temp1,Y
	st	X+,Temp1		;   

	ld	Temp1,Z+		;   
	movw	YL,ZL
	ldi2	ZH,high(day_n*2),ZL,low(day_n*2)
	clr	Temp3
	lsl	Temp1
	rol	Temp3
	add	ZL,Temp1
	adc	ZH,Temp3
	lpm	Temp1,Z+		;  
	st	X+,Temp1
	lpm	Temp1,Z		;  
	st	X+,Temp1
	movw	ZL,YL

	sbrs	Temp2,ALR_LAMP_ON	;  ,  
	rjmp	ind_alr3
	ldi	Temp1,$a7
	st	X+,Temp1
	ldi	Temp1,'M'
	st	X+,Temp1
	ldi	Temp1,$a8		; ""
	st	X+,Temp1
	rjmp	ind_alr4
ind_alr3:	adiw	XL,3
ind_alr4:	ldd	Temp1,Z+1		;  
	ldi2	YH,high(fASCIIL),YL,low(fASCIIL)
	st	Y+,Temp1
	clr	Temp1
	st	Y,Temp1
	call	bin2ASCII16
	ldi2	YH,high(tASCII1),YL,low(tASCII1)
	ld	Temp1,Y+
	st	X+,Temp1		;  
	ld	Temp1,Y+
	st	X+,Temp1		;  
	sbrs	Temp2,ALR_SEARCH_ON	;   ,  
	rjmp	ind_alr5
	ldi	Temp1,$be
	st	X+,Temp1
	ldi	Temp1,'e'
	st	X+,Temp1
	ldi	Temp1,'p'		; ""
	st	X+,Temp1
	ret
ind_alr5:	sbrs	Temp2,ALR_MUS_ON	;  ,  
	rjmp	ind_alr6
	ldi	Temp1,$b3
	st	X+,Temp1
	ldi	Temp1,$ba
	st	X+,Temp1
	ldi	Temp1,$bb		; ""
	st	X+,Temp1
	ret
ind_alr6:	ldi	Temp1,'o'
	st	X+,Temp1
	ldi	Temp1,$bf
	st	X+,Temp1
	ldi	Temp1,$ba		; ""
	st	X+,Temp1
	ret

;--------------------------------------------------------------------------------------------------------------


tim_ovf0:			;    0

	in	SSREG,SREG
	push	Temp1

	ldio	TCCR0,0		;  0
	CLRB	FlagsLCD,LCD_TIM_ON;  LCD_TIM_ON
	chnc	TIMSK,(1<<TOIE0)	; 

	pop	Temp1
	out	SREG,SSREG
	reti

;**********

ext_int1:			;   

	in	SSREG,SREG
	push	Temp1

	SETB	FlagsButton,BUT_ON	;    
	chnc	GICR,(1<<Sb_Int)
 	ldi	Temp1,_TimBoun
	sts	CntBut,Temp1	;  CntBut

	pop	Temp1
	out	SREG,SSREG
	reti

;***********

tim2_comp:			;    

	in	SSREG,SREG

	SETB	Flags,TIM_SECOND	;  
	inc	Second		;  (*4)
	wdr
	out	SREG,SSREG
	reti

;**********

adcc:			;    
	in	SSREG,SREG
	push	DataH
	push	DataL
	push	Temp1
	push	Temp2
	push	Temp3
	push	Temp4
	push	ZL
	push	ZH

	wdr

	ldi2	ZH,high(DataAverage),ZL,low(DataAverage)
	lds	Temp3,CntDataAver
	clr	Temp4
	add	ZL,Temp3
	adc	ZH,Temp4
	in	Temp4,ADCL
	st	Z+,Temp4		;   ( )
	in	Temp4,ADCH
	st	Z+,Temp4		;   ( )
	subi	Temp3,(-2)		;+2
	cpi	Temp3,_AverNumb*2	;  ?
	brne	adcav1		;
				;
	clr	Temp3
	ldi	Temp4,_AverNumb
	clr	DataL
	clr	DataH
adcav3:	ld	Temp1,-Z		;
	ld	Temp2,-Z
	add	DataL,Temp2		; 
	adc	DataH,Temp1		; 
	dec	Temp4
	brne	adcav3

	ldi	Temp4,6		;
adcav4:	lsr	DataH		; 
	ror	DataL		; 
	dec	Temp4
	brne	adcav4

	in	Temp2,ADMUX
	mov	Temp1,Temp2
	andi	Temp1,$3f		;   

	ldi2	ZH,high(DataTerm1L),ZL,low(DataTerm1L)
	lsl	Temp1		;    2
	clr	Temp4
	add	ZL,Temp1		;      
	adc	ZH,Temp4
	st	Z+,DataL		;   ( )
	st	Z+,DataH		;   ( )

	lsr	Temp1		;    2
	inc	Temp1		;   
	cpi	Temp1,_ADCNumb	;  ?
	brne	adcc1
	ldi	Temp1,3
adcc1:	andi	Temp2,$c0		;  
	or	Temp2,Temp1
	out	ADMUX,Temp2

adcav1:	sts	CntDataAver,Temp3

	chns	ADCSRA,(1<<ADSC)	; 
	pop	ZH
	pop	ZL
	pop	Temp4
	pop	Temp3
	pop	Temp2
	pop	Temp1
	pop	DataL
	pop	DataH
	out	SREG,SSREG
	reti

;***************

ext_int0:			;    

	in	SSREG,SREG
	push	Temp1

	SETB	Flags,POWER_OFF	;   
	chnc	GICR,(1<<INT0)	;    

	pop	Temp1
	out	SREG,SSREG
	reti

;***************

ana_comp:			;  

	in	SSREG,SREG
	push	Temp1
	push	Temp2
	push	Temp3
	push	Temp4
	push	ZL
	push	ZH

	SKBC	Flags,SOUND_ON	;    ,  
	rjmp	ancc111
	lds	Temp1,CntRead1W	;   
	dec	Temp1
	sts	CntRead1W,Temp1
	brne	ancc111
	ldi	Temp1,cTimeRead1W
	sts	CntRead1W,Temp1
	SETB	FlagsLCD, ONEW_ON

ancc111:	ldio	TCCR1B,0		;  1
	ldio	TCNT1H,0
	ldio	TCNT1L,0

	ldio	TCCR1A,$f0		;  1-     
	chns	TCCR1A,(1<<FOC1A)+(1<<FOC1B);    1
	ldio	TCCR1A,0		;
	SKBS	Flags,LOAD_ON	;   ,  
	rjmp	ancc1
	chns	TCCR1A,(1<<COM1B1)	;   1  
ancc1:	SKBS	Flags,LAMP_ON	;   ,  
	rjmp	ancc2
	chns	TCCR1A,(1<<COM1A1)	;   1  
ancc2:
	SKBC	Flags,LAMP_ON	;   ,  
	rjmp	anc22
	SKBS	Flags,LOAD_ON	;   ,  
	rjmp	anc1

anc22:	lds	Temp1,Adjust1H	;    -
	lds	Temp2,Adjust1L	;    -
	lds	Temp3,AdjustMem1H	;    
	lds	Temp4,AdjustMem1L	;    
	subi	Temp2,low(_Step)
	sbci	Temp1,high(_Step)	; 
	cp	Temp2,Temp4		;  
	cpc	Temp1,Temp3		;  
	brge	anc21		; Adjust>=AdjustMem,  
	movw	Temp1,Temp3		;Adjust=AdjustMem
anc21:
	sts	Adjust1H,Temp1
	sts	Adjust1L,Temp2
	out	OCR1AH,Temp1
	out	OCR1AL,Temp2
	lds	Temp3,Adjust2H	;     
	lds	Temp4,Adjust2L	;     
	out	OCR1BH,Temp3
	out	OCR1BL,Temp4
	ldio	TCCR1B,1		;  1,=1

anc1:
	ldi2	ZH,high(CntBut),ZL,low(CntBut)
	ld	Temp1,Z
	tst	Temp1		;    0
	breq	anc3		;  =0,  
	dec	Temp1
anc3:	st	Z+,Temp1

	ld	Temp1,Z		;CntButDelay
	tst	Temp1		;   0
	breq	anc5
	dec	Temp1
	brne	anc5
	SETB	FlagsButton,MULTI
	SETB	FlagsButton,MULTI_CNT
	ldi	Temp2,_TimCntSet
	std	Z+1,Temp2		;  CntButSet
anc5:	st	Z+,Temp1

	ld	Temp1,Z		;CntButSet
	tst	Temp1		;   0
	breq	anc7
	dec	Temp1
anc7:	st	Z+,Temp1

	ld	Temp2,Z		;CntBeep
	tst	Temp2		;   0
	breq	anc8
	dec	Temp2
	brne	anc8
	ldio	TCCR0,0		; 
	chnc	TIMSK,(1<<OCIE0)	; 
	cbi	PORTB,ZP
	CLRB	Flags,BEEPING
	lds	Temp1,FlagsRAM
	sbrs	Temp1,SOUND_PAUSE	;  , 
	rjmp	anc8
		;   
	SETB	Flags,BEEPING
	cbr	Temp1,(1<<SOUND_PAUSE)	;    
	sts	FlagsRAM,Temp1
	ldi	Temp2,2
anc8:	st	Z+,Temp2

	pop	ZH
	pop	ZL
	pop	Temp4
	pop	Temp3
	pop	Temp2
	pop	Temp1
	out	SREG,SSREG
	reti

;**************

timer0_comp:			;    0

	in	SSREG,SREG
	sbic	PINB,ZP	;  ,  
	rjmp	tmr0_cmp1
	sbi	PORTB,ZP
	out	SREG,SSREG
	reti
tmr0_cmp1:	cbi	PORTB,ZP
	out	SREG,SSREG
	reti


;-------------------------------------------------------------------------------------------------------------------

.include	"text.inc"


date:		;   
.db	10,32,29,32,31,32,31,32,32,31,32,31,32

day_n:		; 
.db	$be,$bd,$b3,$bf,'c','p',$c0,$bf,$be,$bf,'c',$b2,$b3,'c',$ba,$e3,$b2,$e3
;	                                                 
;- , - 

mymelody:			;

.include	"mel.inc"		;begin melodies

.include	"1wire.inc"

.include	"LCD16.inc"
.include	"2-10_16.inc"


.eseg			;    EEPROM
.org	0
.dw	$6,$39b,$172d,0,$6,$39b,$172d,0,$6,$39b,$172d,0

.org	_TPoint0
.db	0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max)
.db	0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max)
.db	0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max)
.db	0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max),0,0,0,low(_Max),high(_Max)

.org	400
notes:		;  

.db	((_fsck)/(262*2)),((_fsck)/(277*2)),((_fsck)/(294*2)),((_fsck)/(311*2)),((_fsck)/(330*2)),((_fsck)/(349*2))
.db	((_fsck)/(370*2)),((_fsck)/(392*2)),((_fsck)/(415*2)),((_fsck)/(440*2)),((_fsck)/(466*2)),((_fsck)/(494*2))
.db	((_fsck)/(262*2*2)),((_fsck)/(277*2*2)),((_fsck)/(294*2*2)),((_fsck)/(311*2*2)),((_fsck)/(330*2*2)),((_fsck)/(349*2*2))
.db	((_fsck)/(370*2*2)),((_fsck)/(392*2*2)),((_fsck)/(415*2*2)),((_fsck)/(440*2*2)),((_fsck)/(466*2*2)),((_fsck)/(494*2*2))
.db	((_fsck)/(262*4*2)),((_fsck)/(277*4*2)),((_fsck)/(294*4*2)),((_fsck)/(311*4*2)),((_fsck)/(330*4*2)),((_fsck)/(349*4*2))
.db	((_fsck)/(370*4*2)),((_fsck)/(392*4*2)),((_fsck)/(415*4*2)),((_fsck)/(440*4*2)),((_fsck)/(466*4*2)),((_fsck)/(494*4*2))

.exit
